;'use strict';(function(window){var gL10nData={};var gTextProp='textContent';var gLanguage='';var gMacros={};var gReadyState='loading';var gAsyncResourceLoading=true;var gDEBUG=1;function consoleLog(message){if(gDEBUG>=2){console.log('[l10n] '+message);}};function consoleWarn(message){if(gDEBUG){console.warn('[l10n] '+message);}};function getL10nResourceLinks(){return document.querySelectorAll('link[type="application/l10n"]');}
function getL10nDictionary(){var script=document.querySelector('script[type="application/l10n"]');return script?JSON.parse(script.innerHTML):null;}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function getL10nAttributes(element){if(!element)
return{};var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args={};if(l10nArgs){try{args=JSON.parse(l10nArgs);}catch(e){consoleWarn('could not parse arguments for #'+l10nId);}}
return{id:l10nId,args:args};}
function fireL10nReadyEvent(){var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=gLanguage;window.dispatchEvent(evtObject);}
function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/\/[^\/]*$/,'/');function evalString(text){if(text.lastIndexOf('\\')<0)
return text;return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text){var dictionary=[];var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax){var entries=rawText.replace(reBlank,'').split(/[\r\n]+/);var currentLang='*';var genericLang=lang.replace(/-[a-z]+$/i,'');var skipLang=false;var match='';for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(extendedSyntax){if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=='*')&&(currentLang!==lang)&&(currentLang!==genericLang);continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);loadImport(baseURL+match[1]);}}
var tmp=line.match(reSplit);if(tmp&&tmp.length==3){dictionary[tmp[1]]=evalString(tmp[2]);}}}
function loadImport(url){loadResource(url,function(content){parseRawLines(content,false);},null,false);}
parseRawLines(text,true);return dictionary;}
function loadResource(url,onSuccess,onFailure,asynchronous){onSuccess=onSuccess||function _onSuccess(data){};onFailure=onFailure||function _onFailure(){consoleWarn(url+' not found.');};var xhr=new XMLHttpRequest();xhr.open('GET',url,asynchronous);if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain; charset=utf-8');}
xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status===0){onSuccess(xhr.responseText);}else{onFailure();}}};xhr.onerror=onFailure;xhr.ontimeout=onFailure;try{xhr.send(null);}catch(e){onFailure();}}
loadResource(href,function(response){var data=parseProperties(response);for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop=gTextProp;}
if(!gL10nData[id]){gL10nData[id]={};}
gL10nData[id][prop]=data[key];}
if(successCallback){successCallback();}},failureCallback,gAsyncResourceLoading);};function loadLocale(lang,callback){callback=callback||function _callback(){};clear();gLanguage=lang;var langLinks=getL10nResourceLinks();var langCount=langLinks.length;if(langCount==0){var dict=getL10nDictionary();if(dict&&dict.locales&&dict.default_locale){consoleLog('using the embedded JSON directory, early way out');gL10nData=dict.locales[lang]||dict.locales[dict.default_locale];callback();}else{consoleLog('no resource to load, early way out');}
fireL10nReadyEvent(lang);gReadyState='complete';return;}
var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){callback();fireL10nReadyEvent(lang);gReadyState='complete';}};function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;parseResource(href,lang,callback,function(){consoleWarn(href+' not found.');applied='';});return applied;};}
for(var i=0;i<langCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang){consoleWarn('"'+lang+'" resource not found');gLanguage='';}}}
function clear(){gL10nData={};gLanguage='';}
function getPluralRules(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return start<=n&&n<=end;}
var pluralRules={'0':function(n){return'other';},'1':function(n){if((isBetween((n%100),3,10)))
return'few';if(n===0)
return'zero';if((isBetween((n%100),11,99)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'2':function(n){if(n!==0&&(n%10)===0)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'3':function(n){if(n==1)
return'one';return'other';},'4':function(n){if((isBetween(n,0,1)))
return'one';return'other';},'5':function(n){if((isBetween(n,0,2))&&n!=2)
return'one';return'other';},'6':function(n){if(n===0)
return'zero';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'7':function(n){if(n==2)
return'two';if(n==1)
return'one';return'other';},'8':function(n){if((isBetween(n,3,6)))
return'few';if((isBetween(n,7,10)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'9':function(n){if(n===0||n!=1&&(isBetween((n%100),1,19)))
return'few';if(n==1)
return'one';return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19)))
return'few';if((n%10)==1&&!(isBetween((n%100),11,19)))
return'one';return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14)))
return'many';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'12':function(n){if((isBetween(n,2,4)))
return'few';if(n==1)
return'one';return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if(n!=1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14)))
return'many';if(n==1)
return'one';return'other';},'14':function(n){if((isBetween((n%100),3,4)))
return'few';if((n%100)==2)
return'two';if((n%100)==1)
return'one';return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10)))
return'few';if((isBetween((n%100),11,19)))
return'many';if(n==1)
return'one';return'other';},'16':function(n){if((n%10)==1&&n!=11)
return'one';return'other';},'17':function(n){if(n==3)
return'few';if(n===0)
return'zero';if(n==6)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'18':function(n){if(n===0)
return'zero';if((isBetween(n,0,2))&&n!==0&&n!=2)
return'one';return'other';},'19':function(n){if((isBetween(n,2,10)))
return'few';if((isBetween(n,0,1)))
return'one';return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)==9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99)))
return'few';if((n%1000000)===0&&n!==0)
return'many';if((n%10)==2&&!isIn((n%100),[12,72,92]))
return'two';if((n%10)==1&&!isIn((n%100),[11,71,91]))
return'one';return'other';},'21':function(n){if(n===0)
return'zero';if(n==1)
return'one';return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99)))
return'one';return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0)
return'one';return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19)))
return'few';if(isIn(n,[2,12]))
return'two';if(isIn(n,[1,11]))
return'one';return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){consoleWarn('plural form unknown for ['+lang+']');return function(){return'other';};}
return pluralRules[index];}
gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))
return str;if(prop!=gTextProp)
return str;if(!gMacros._pluralRules){gMacros._pluralRules=getPluralRules(gLanguage);}
var index='['+gMacros._pluralRules(n)+']';if(n===0&&(key+'[zero]')in gL10nData){str=gL10nData[key+'[zero]'][prop];}else if(n==1&&(key+'[one]')in gL10nData){str=gL10nData[key+'[one]'][prop];}else if(n==2&&(key+'[two]')in gL10nData){str=gL10nData[key+'[two]'][prop];}else if((key+index)in gL10nData){str=gL10nData[key+index][prop];}else if((key+'[other]')in gL10nData){str=gL10nData[key+'[other]'][prop];}
return str;};function getL10nData(key,args){var data=gL10nData[key];if(!data){consoleWarn('#'+key+' is undefined.');}
var rv={};for(var prop in data){var str=data[prop];str=substIndexes(str,args,key,prop);str=substArguments(str,args,key);rv[prop]=str;}
return rv;}
function substIndexes(str,args,key,prop){var reIndex=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;var reMatch=reIndex.exec(str);if(!reMatch||!reMatch.length)
return str;var macroName=reMatch[1];var paramName=reMatch[2];var param;if(args&&paramName in args){param=args[paramName];}else if(paramName in gL10nData){param=gL10nData[paramName];}
if(macroName in gMacros){var macro=gMacros[macroName];str=macro(str,param,key,prop);}
return str;}
function substArguments(str,args,key){var reArgs=/\{\{\s*(.+?)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(args&&arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg][gTextProp];}else{consoleLog('argument {{'+arg+'}} for #'+key+' is undefined.');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var data=getL10nData(l10n.id,l10n.args);if(!data){consoleWarn('#'+l10n.id+' is undefined.');return;}
if(data[gTextProp]){if(element.children.length===0){element[gTextProp]=data[gTextProp];}else{var children=element.childNodes;var found=false;for(var i=0,l=children.length;i<l;i++){if(children[i].nodeType===3&&/\S/.test(children[i].nodeValue)){if(found){children[i].nodeValue='';}else{children[i].nodeValue=data[gTextProp];found=true;}}}
if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild);}}
delete data[gTextProp];}
for(var k in data){element[k]=data[k];}}
function translateFragment(element){element=element||document.documentElement;var children=getTranslatableChildren(element);var elementCount=children.length;for(var i=0;i<elementCount;i++){translateElement(children[i]);}
translateElement(element);}
function l10nStartup(){gReadyState='interactive';consoleLog('loading ['+navigator.language+'] resources, '+
(gAsyncResourceLoading?'asynchronously.':'synchronously.'));if(document.documentElement.lang===navigator.language){loadLocale(navigator.language);}else{loadLocale(navigator.language,translateFragment);}}
if(typeof(document)!=='undefined'){if(document.readyState==='complete'||document.readyState==='interactive'){window.setTimeout(l10nStartup);}else{document.addEventListener('DOMContentLoaded',l10nStartup);}}
if('mozSettings'in navigator&&navigator.mozSettings){navigator.mozSettings.addObserver('language.current',function(event){loadLocale(event.settingValue,translateFragment);});}
navigator.mozL10n={get:function l10n_get(key,args,fallback){var data=getL10nData(key,args)||fallback;if(data){return'textContent'in data?data.textContent:'';}
return'{{'+key+'}}';},get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};},translate:translateFragment,get dictionary(){return JSON.parse(JSON.stringify(gL10nData));},get readyState(){return gReadyState;},ready:function l10n_ready(callback){if(!callback){return;}else if(gReadyState=='complete'||gReadyState=='interactive'){window.setTimeout(callback);}else{window.addEventListener('localized',callback);}}};consoleLog('library loaded.');})(this);;'use strict';navigator.mozL10n.DateTimeFormat=function(locales,options){var _=navigator.mozL10n.get;function localeFormat(d,format){var tokens=format.match(/(%E.|%O.|%.)/g);for(var i=0;tokens&&i<tokens.length;i++){var value='';switch(tokens[i]){case'%a':value=_('weekday-'+d.getDay()+'-short');break;case'%A':value=_('weekday-'+d.getDay()+'-long');break;case'%b':case'%h':value=_('month-'+d.getMonth()+'-short');break;case'%B':value=_('month-'+d.getMonth()+'-long');break;case'%Eb':value=_('month-'+d.getMonth()+'-genitive');break;case'%I':value=d.getHours()%12||12;break;case'%e':value=d.getDate();break;case'%c':case'%x':case'%X':var tmp=_('dateTimeFormat_'+tokens[i]);if(tmp&&!(/(%c|%x|%X)/).test(tmp)){value=localeFormat(d,tmp);}
break;}
format=format.replace(tokens[i],value||d.toLocaleFormat(tokens[i]));}
return format;}
function prettyDate(time,useCompactFormat){switch(time.constructor){case String:time=parseInt(time);break;case Date:time=time.getTime();break;}
var secDiff=(Date.now()-time)/1000;if(isNaN(secDiff)){return _('incorrectDate');}
var f=useCompactFormat?'-short':'-long';if(secDiff>=0){var dayDiff=Math.floor(secDiff/86400);if(secDiff<3600){return _('minutesAgo'+f,{m:Math.floor(secDiff/60)});}else if(dayDiff===0){return _('hoursAgo'+f,{h:Math.floor(secDiff/3600)});}else if(dayDiff<10){return _('daysAgo'+f,{d:dayDiff});}}
if(secDiff<0){secDiff=-secDiff;dayDiff=Math.floor(secDiff/86400);if(secDiff<3600){return _('inMinutes'+f,{m:Math.floor(secDiff/60)});}else if(dayDiff===0){return _('inHours'+f,{h:Math.floor(secDiff/3600)});}else if(dayDiff<10){return _('inDays'+f,{d:dayDiff});}}
return localeFormat(new Date(time),'%x');}
return{localeDateString:function localeDateString(d){return localeFormat(d,'%x');},localeTimeString:function localeTimeString(d){return localeFormat(d,'%X');},localeString:function localeString(d){return localeFormat(d,'%c');},localeFormat:localeFormat,fromNow:prettyDate};};;'use strict';var GestureDetector=(function(){function GD(e,options){this.element=e;this.options=options||{};this.state=initialState;this.timers={};this.listeningForMouseEvents=true;}
GD.prototype.startDetecting=function(){var self=this;eventtypes.forEach(function(t){self.element.addEventListener(t,self);});};GD.prototype.stopDetecting=function(){var self=this;eventtypes.forEach(function(t){self.element.removeEventListener(t,self);});};GD.prototype.handleEvent=function(e){var handler=this.state[e.type];if(!handler)return;if(e.changedTouches){if(this.listeningForMouseEvents){this.listeningForMouseEvents=false;this.element.removeEventListener('mousedown',this);}
if(e.type==='touchend'&&e.changedTouches.length>1){console.warn('gesture_detector.js: spurious extra changed touch on '+'touchend. See '+'https://bugzilla.mozilla.org/show_bug.cgi?id=785554');}
for(var i=0;i<e.changedTouches.length;i++){handler(this,e,e.changedTouches[i]);handler=this.state[e.type];}}
else{handler(this,e);}};GD.prototype.startTimer=function(type,time){this.clearTimer(type);var self=this;this.timers[type]=setTimeout(function(){self.timers[type]=null;var handler=self.state[type];if(handler)
handler(self,type);},time);};GD.prototype.clearTimer=function(type){if(this.timers[type]){clearTimeout(this.timers[type]);this.timers[type]=null;}};GD.prototype.switchTo=function(state,event,touch){this.state=state;if(state.init)
state.init(this,event,touch);};GD.prototype.emitEvent=function(type,detail){if(!this.target){console.error('Attempt to emit event with no target');return;}
var event=this.element.ownerDocument.createEvent('CustomEvent');event.initCustomEvent(type,true,true,detail);this.target.dispatchEvent(event);}
GD.HOLD_INTERVAL=1000;GD.PAN_THRESHOLD=20;GD.MOUSE_PAN_THRESHOLD=15;GD.DOUBLE_TAP_DISTANCE=50;GD.DOUBLE_TAP_TIME=500;GD.VELOCITY_SMOOTHING=.5;GD.SCALE_THRESHOLD=20;GD.ROTATE_THRESHOLD=22.5;GD.THRESHOLD_SMOOTHING=0.9;var abs=Math.abs,floor=Math.floor,sqrt=Math.sqrt,atan2=Math.atan2;var PI=Math.PI;var eventtypes=['touchstart','touchmove','touchend','mousedown'];function eventTime(e){var ts=e.timeStamp;if(ts>2*Date.now())
return Math.floor(ts/1000);else
return ts;}
function coordinates(e,t){return Object.freeze({screenX:t.screenX,screenY:t.screenY,clientX:t.clientX,clientY:t.clientY,timeStamp:eventTime(e)});}
function midpoints(e,t1,t2){return Object.freeze({screenX:floor((t1.screenX+t2.screenX)/2),screenY:floor((t1.screenY+t2.screenY)/2),clientX:floor((t1.clientX+t2.clientX)/2),clientY:floor((t1.clientY+t2.clientY)/2),timeStamp:eventTime(e)});}
function mouseCoordinates(e){return Object.freeze({screenX:e.screenX,screenY:e.screenY,clientX:e.clientX,clientY:e.clientY,timeStamp:eventTime(e)});}
function between(c1,c2){var r=GD.THRESHOLD_SMOOTHING;return Object.freeze({screenX:floor(c1.screenX+r*(c2.screenX-c1.screenX)),screenY:floor(c1.screenY+r*(c2.screenY-c1.screenY)),clientX:floor(c1.clientX+r*(c2.clientX-c1.clientX)),clientY:floor(c1.clientY+r*(c2.clientY-c1.clientY)),timeStamp:floor(c1.timeStamp+r*(c2.timeStamp-c1.timeStamp))});}
function touchDistance(t1,t2){var dx=t2.screenX-t1.screenX;var dy=t2.screenY-t1.screenY;return sqrt(dx*dx+dy*dy);}
function touchDirection(t1,t2){return atan2(t2.screenY-t1.screenY,t2.screenX-t1.screenX)*180/PI;}
function touchRotation(d1,d2){var angle=d2-d1;if(angle>180)
angle-=360;else if(angle<=-180)
angle+=360;return angle;}
function isDoubleTap(lastTap,thisTap){var dx=abs(thisTap.screenX-lastTap.screenX);var dy=abs(thisTap.screenY-lastTap.screenY);var dt=thisTap.timeStamp-lastTap.timeStamp;return(dx<GD.DOUBLE_TAP_DISTANCE&&dy<GD.DOUBLE_TAP_DISTANCE&&dt<GD.DOUBLE_TAP_TIME);}
var initialState={name:'initialState',init:function(d){d.target=null;d.start=d.last=null;d.touch1=d.touch2=null;d.vx=d.vy=null;d.startDistance=d.lastDistance=null;d.startDirection=d.lastDirection=null;d.lastMidpoint=null;d.scaled=d.rotated=null;},touchstart:function(d,e,t){d.switchTo(touchStartedState,e,t);},mousedown:function(d,e){d.switchTo(mouseDownState,e);}};var touchStartedState={name:'touchStartedState',init:function(d,e,t){d.target=e.target;d.touch1=t.identifier;d.start=d.last=coordinates(e,t);if(d.options.holdEvents)
d.startTimer('holdtimeout',GD.HOLD_INTERVAL);},touchstart:function(d,e,t){d.clearTimer('holdtimeout');d.switchTo(transformState,e,t);},touchmove:function(d,e,t){if(t.identifier!==d.touch1)
return;if(abs(t.screenX-d.start.screenX)>GD.PAN_THRESHOLD||abs(t.screenY-d.start.screenY)>GD.PAN_THRESHOLD){d.clearTimer('holdtimeout');d.switchTo(panStartedState,e,t);}},touchend:function(d,e,t){if(t.identifier!==d.touch1)
return;if(d.lastTap&&isDoubleTap(d.lastTap,d.start)){d.emitEvent('tap',d.start);d.emitEvent('dbltap',d.start);d.lastTap=null;}
else{d.emitEvent('tap',d.start);d.lastTap=coordinates(e,t);}
d.clearTimer('holdtimeout');d.switchTo(initialState);},holdtimeout:function(d){d.switchTo(holdState);}};var panStartedState={name:'panStartedState',init:function(d,e,t){d.start=d.last=between(d.start,coordinates(e,t));if(e.type==='touchmove')
panStartedState.touchmove(d,e,t);},touchmove:function(d,e,t){if(t.identifier!==d.touch1)
return;var current=coordinates(e,t);d.emitEvent('pan',{absolute:{dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY},relative:{dx:current.screenX-d.last.screenX,dy:current.screenY-d.last.screenY},position:current});var dt=current.timeStamp-d.last.timeStamp;var vx=(current.screenX-d.last.screenX)/dt;var vy=(current.screenY-d.last.screenY)/dt;if(d.vx==null){d.vx=vx;d.vy=vy;}
else{d.vx=d.vx*GD.VELOCITY_SMOOTHING+
vx*(1-GD.VELOCITY_SMOOTHING);d.vy=d.vy*GD.VELOCITY_SMOOTHING+
vy*(1-GD.VELOCITY_SMOOTHING);}
d.last=current;},touchend:function(d,e,t){if(t.identifier!==d.touch1)
return;var current=coordinates(e,t);var dx=current.screenX-d.start.screenX;var dy=current.screenY-d.start.screenY;var angle=atan2(dy,dx)*180/PI;if(angle<0)
angle+=360;var direction;if(angle>=315||angle<45)
direction='right';else if(angle>=45&&angle<135)
direction='down';else if(angle>=135&&angle<225)
direction='left';else if(angle>=225&&angle<315)
direction='up';d.emitEvent('swipe',{start:d.start,end:current,dx:dx,dy:dy,dt:e.timeStamp-d.start.timeStamp,vx:d.vx,vy:d.vy,direction:direction,angle:angle});d.switchTo(initialState);}};var holdState={name:'holdState',init:function(d){d.emitEvent('holdstart',d.start);},touchmove:function(d,e,t){var current=coordinates(e,t);d.emitEvent('holdmove',{absolute:{dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY},relative:{dx:current.screenX-d.last.screenX,dy:current.screenY-d.last.screenY},position:current});d.last=current;},touchend:function(d,e,t){var current=coordinates(e,t);d.emitEvent('holdend',{start:d.start,end:current,dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY});d.switchTo(initialState);}};var transformState={name:'transformState',init:function(d,e,t){d.touch2=t.identifier;var t1=e.touches.identifiedTouch(d.touch1);var t2=e.touches.identifiedTouch(d.touch2);d.startDistance=d.lastDistance=touchDistance(t1,t2);d.startDirection=d.lastDirection=touchDirection(t1,t2);d.scaled=d.rotated=false;},touchmove:function(d,e,t){if(t.identifier!==d.touch1&&t.identifier!==d.touch2)
return;var t1=e.touches.identifiedTouch(d.touch1);var t2=e.touches.identifiedTouch(d.touch2);var midpoint=midpoints(e,t1,t2);var distance=touchDistance(t1,t2);var direction=touchDirection(t1,t2);var rotation=touchRotation(d.startDirection,direction);if(!d.scaled){if(abs(distance-d.startDistance)>GD.SCALE_THRESHOLD){d.scaled=true;d.startDistance=d.lastDistance=floor(d.startDistance+
GD.THRESHOLD_SMOOTHING*(distance-d.startDistance));}
else
distance=d.startDistance;}
if(!d.rotated){if(abs(rotation)>GD.ROTATE_THRESHOLD)
d.rotated=true;else
direction=d.startDirection;}
if(d.scaled||d.rotated){d.emitEvent('transform',{absolute:{scale:distance/d.startDistance,rotate:touchRotation(d.startDirection,direction)},relative:{scale:distance/d.lastDistance,rotate:touchRotation(d.lastDirection,direction)},midpoint:midpoint});d.lastDistance=distance;d.lastDirection=direction;d.lastMidpoint=midpoint;}},touchend:function(d,e,t){if(t.identifier===d.touch2)
d.touch2=null;else if(t.identifier===d.touch1){d.touch1=d.touch2;d.touch2=null;}
else
return;if(d.scaled||d.rotated){d.emitEvent('transformend',{absolute:{scale:d.lastDistance/d.startDistance,rotate:touchRotation(d.startDirection,d.lastDirection)},relative:{scale:1,rotate:0},midpoint:d.lastMidpoint});}
d.switchTo(afterTransformState);}};var afterTransformState={name:'afterTransformState',touchstart:function(d,e,t){d.switchTo(transformState,e,t);},touchend:function(d,e,t){if(t.identifier===d.touch1)
d.switchTo(initialState);}};var mouseDownState={name:'mouseDownState',init:function(d,e){d.target=e.target;var doc=d.element.ownerDocument;doc.addEventListener('mousemove',d,true);doc.addEventListener('mouseup',d,true);d.start=d.last=mouseCoordinates(e);if(d.options.holdEvents)
d.startTimer('holdtimeout',GD.HOLD_INTERVAL);},mousemove:function(d,e){if(abs(e.screenX-d.start.screenX)>GD.MOUSE_PAN_THRESHOLD||abs(e.screenY-d.start.screenY)>GD.MOUSE_PAN_THRESHOLD){d.clearTimer('holdtimeout');d.switchTo(mousePannedState,e);}},mouseup:function(d,e){var doc=d.element.ownerDocument;doc.removeEventListener('mousemove',d,true);doc.removeEventListener('mouseup',d,true);if(d.lastTap&&isDoubleTap(d.lastTap,d.start)){d.emitEvent('tap',d.start);d.emitEvent('dbltap',d.start);d.lastTap=null;}
else{d.emitEvent('tap',d.start);d.lastTap=mouseCoordinates(e);}
d.clearTimer('holdtimeout');d.switchTo(initialState);},holdtimeout:function(d){d.switchTo(mouseHoldState);}};var mouseHoldState={name:'mouseHoldState',init:function(d){d.emitEvent('holdstart',d.start);},mousemove:function(d,e){var current=mouseCoordinates(e);d.emitEvent('holdmove',{absolute:{dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY},relative:{dx:current.screenX-d.last.screenX,dy:current.screenY-d.last.screenY},position:current});d.last=current;},mouseup:function(d,e){var current=mouseCoordinates(e);d.emitEvent('holdend',{start:d.start,end:current,dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY});d.switchTo(initialState);}};var mousePannedState={name:'mousePannedState',init:function(d,e){d.start=d.last=between(d.start,mouseCoordinates(e));if(e.type==='mousemove')
mousePannedState.mousemove(d,e);},mousemove:function(d,e){var current=mouseCoordinates(e);d.emitEvent('pan',{absolute:{dx:current.screenX-d.start.screenX,dy:current.screenY-d.start.screenY},relative:{dx:current.screenX-d.last.screenX,dy:current.screenY-d.last.screenY},position:current});var dt=current.timeStamp-d.last.timeStamp;var vx=(current.screenX-d.last.screenX)/dt;var vy=(current.screenY-d.last.screenY)/dt;if(d.vx==null){d.vx=vx;d.vy=vy;}
else{d.vx=d.vx*GD.VELOCITY_SMOOTHING+
vx*(1-GD.VELOCITY_SMOOTHING);d.vy=d.vy*GD.VELOCITY_SMOOTHING+
vy*(1-GD.VELOCITY_SMOOTHING);}
d.last=current;},mouseup:function(d,e){var doc=d.element.ownerDocument;doc.removeEventListener('mousemove',d,true);doc.removeEventListener('mouseup',d,true);var current=mouseCoordinates(e);var dx=current.screenX-d.start.screenX;var dy=current.screenY-d.start.screenY;var angle=atan2(dy,dx)*180/PI;if(angle<0)
angle+=360;var direction;if(angle>=315||angle<45)
direction='right';else if(angle>=45&&angle<135)
direction='down';else if(angle>=135&&angle<225)
direction='left';else if(angle>=225&&angle<315)
direction='up';d.emitEvent('swipe',{start:d.start,end:current,dx:dx,dy:dy,dt:current.timeStamp-d.start.timeStamp,vx:d.vx,vy:d.vy,direction:direction,angle:angle});d.switchTo(initialState);}};return GD;}());;function hookupInputAreaResetButtons(e){var selector='form p input + button[type="reset"],'+'form p textarea + button[type="reset"]';var resetButtons=e.querySelectorAll(selector);for(var i=0,n=resetButtons.length;i<n;i++){resetButtons[i].addEventListener('mousedown',function(e){e.preventDefault();});resetButtons[i].addEventListener('click',function(e){e.target.previousElementSibling.value='';e.preventDefault();});}};if('mozTCPSocket'in window.navigator){function consoleHelper(){var msg=arguments[0]+':';for(var i=1;i<arguments.length;i++){msg+=' '+arguments[i];}
msg+='\x1b[0m\n';dump(msg);}
window.console={log:consoleHelper.bind(null,'\x1b[32mLOG'),error:consoleHelper.bind(null,'\x1b[31mERR'),info:consoleHelper.bind(null,'\x1b[36mINF'),warn:consoleHelper.bind(null,'\x1b[33mWAR')};}
window.onerror=function errHandler(msg,url,line){console.error('onerror reporting:',msg,'@',url,':',line);return false;};;var mozL10n=navigator.mozL10n;var lazyCards={compose:['js/compose-cards.js','style/compose-cards.css'],settings:['js/setup-cards.js','style/setup-cards.css'],setup:['js/setup-cards.js','style/setup-cards.css']};function dieOnFatalError(msg){console.error('FATAL:',msg);throw new Error(msg);}
var fldNodes,msgNodes,cmpNodes,supNodes,tngNodes;function processTemplNodes(prefix){var holder=document.getElementById('templ-'+prefix),nodes={},node=holder.firstElementChild,reInvariant=new RegExp('^'+prefix+'-');while(node){var classes=node.classList,found=false;for(var i=0;i<classes.length;i++){if(reInvariant.test(classes[i])){var name=classes[i].substring(prefix.length+1);nodes[name]=node;found=true;break;}}
if(!found){console.warn('Bad template node for prefix "'+prefix+'" for node with classes:',classes);}
node=node.nextElementSibling;}
return nodes;}
function populateTemplateNodes(){fldNodes=processTemplNodes('fld');msgNodes=processTemplNodes('msg');cmpNodes=processTemplNodes('cmp');supNodes=processTemplNodes('sup');tngNodes=processTemplNodes('tng');}
function addClass(domNode,name){if(domNode){domNode.classList.add(name);}}
function removeClass(domNode,name){if(domNode){domNode.classList.remove(name);}}
function batchAddClass(domNode,searchClass,classToAdd){var nodes=domNode.getElementsByClassName(searchClass);for(var i=0;i<nodes.length;i++){nodes[i].classList.add(classToAdd);}}
function batchRemoveClass(domNode,searchClass,classToRemove){var nodes=domNode.getElementsByClassName(searchClass);for(var i=0;i<nodes.length;i++){nodes[i].classList.remove(classToRemove);}}
var MATCHED_TEXT_CLASS='highlight';function appendMatchItemTo(matchItem,node){var text=matchItem.text;var idx=0;for(var iRun=0;iRun<=matchItem.matchRuns.length;iRun++){var run;if(iRun===matchItem.matchRuns.length)
run={start:text.length,length:0};else
run=matchItem.matchRuns[iRun];if(run.start>idx){var tnode=document.createTextNode(text.substring(idx,run.start));node.appendChild(tnode);}
if(!run.length)
continue;var hspan=document.createElement('span');hspan.classList.add(MATCHED_TEXT_CLASS);hspan.textContent=text.substr(run.start,run.length);node.appendChild(hspan);idx=run.start+run.length;}}
function bindContainerHandler(containerNode,eventName,func){containerNode.addEventListener(eventName,function(event){var node=event.target;if(node===containerNode)
return;while(node&&node.parentNode!==containerNode){node=node.parentNode;}
func(node,event);},false);}
function bindContainerClickAndHold(containerNode,clickFunc,holdFunc){bindContainerHandler(containerNode,'click',function(node,event){if(Cards._suppressClick){Cards._suppressClick=false;return;}
clickFunc(node,event);});bindContainerHandler(containerNode,'contextmenu',function(node,event){event.preventDefault();if(event.button===0){Cards._suppressClick=true;}
return holdFunc(node,event);});}
var Cards={_cardDefs:{},_cardStack:[],activeCardIndex:-1,_zIndex:0,_rootNode:null,_containerNode:null,_cardsNode:null,_templateNodes:null,_animatingDeadDomNodes:[],_transitionCount:0,_suppressClick:false,_trayActive:false,_popupActive:null,_eatingEventsUntilNextCard:false,TRAY_GUTTER_WIDTH:60,_init:function(){this._rootNode=document.body;this._containerNode=document.getElementById('cardContainer');this._cardsNode=document.getElementById('cards');this._templateNodes=processTemplNodes('card');this._containerNode.addEventListener('click',this._onMaybeIntercept.bind(this),true);this._containerNode.addEventListener('contextmenu',this._onMaybeIntercept.bind(this),true);this._cardsNode.addEventListener('transitionend',this._onTransitionEnd.bind(this),false);},_onMaybeIntercept:function(event){if(event.type==='click'&&this._suppressClick){this._suppressClick=false;event.stopPropagation();return;}
if(this._eatingEventsUntilNextCard){event.stopPropagation();return;}
if(this._popupActive){event.stopPropagation();this._popupActive.close();return;}
if(this._trayActive&&(event.clientX>this._containerNode.offsetWidth-this.TRAY_GUTTER_WIDTH)){event.stopPropagation();var targetIndex=-1;this._cardStack.some(function(card,i){if(card.domNode.hasAttribute('data-tray-target')){targetIndex=i;return true;}});if(targetIndex===-1)
targetIndex=this.activeCardIndex+1;var indexDiff=targetIndex-(this.activeCardIndex+1);if(indexDiff>0){this._afterTransitionAction=(function(){this.removeCardAndSuccessors(this._cardStack[0].domNode,'none',indexDiff);this.moveToCard(targetIndex,'animate','forward');}.bind(this));}
this.moveToCard(this.activeCardIndex+1,'animate','forward');}},defineCard:function(cardDef){if(!cardDef.name)
throw new Error('The card type needs a name');if(this._cardDefs.hasOwnProperty(cardDef.name))
throw new Error('Duplicate card name: '+cardDef.name);this._cardDefs[cardDef.name]=cardDef;for(var modeName in cardDef.modes){var mode=cardDef.modes[modeName];if(!mode.hasOwnProperty('tray'))
mode.tray=false;mode.name=modeName;}},defineCardWithDefaultMode:function(name,defaultMode,constructor){var cardDef={name:name,modes:{},constructor:constructor};cardDef.modes['default']=defaultMode;this.defineCard(cardDef);},pushCard:function(type,mode,showMethod,args,placement){var cardDef=this._cardDefs[type];var typePrefix=type.split('-')[0];if(!cardDef&&lazyCards[typePrefix]){var args=Array.slice(arguments);var callback=function(){this.pushCard.apply(this,args);};this.eatEventsUntilNextCard();App.loader.load(lazyCards[typePrefix],callback.bind(this));return;}else if(!cardDef)
throw new Error('No such card def type: '+type);var modeDef=cardDef.modes[mode];if(!modeDef)
throw new Error('No such card mode: '+mode);var domNode=this._templateNodes[type].cloneNode(true);var cardImpl=new cardDef.constructor(domNode,mode,args);var cardInst={domNode:domNode,cardDef:cardDef,modeDef:modeDef,cardImpl:cardImpl};var cardIndex,insertBuddy;if(!placement){cardIndex=this._cardStack.length;insertBuddy=null;domNode.classList.add(cardIndex===0?'before':'after');}
else if(placement==='left'){cardIndex=this.activeCardIndex++;insertBuddy=this._cardsNode.children[cardIndex];domNode.classList.add('before');}
else if(placement==='right'){cardIndex=this.activeCardIndex+1;if(cardIndex>=this._cardStack.length)
insertBuddy=null;else
insertBuddy=this._cardsNode.children[cardIndex];domNode.classList.add('after');}
this._cardStack.splice(cardIndex,0,cardInst);this._cardsNode.insertBefore(domNode,insertBuddy);hookupInputAreaResetButtons(domNode);if('postInsert'in cardImpl)
cardImpl.postInsert();if(showMethod!=='none'){domNode.clientWidth;this._showCard(cardIndex,showMethod,'forward');}},_findCardUsingTypeAndMode:function(type,mode){for(var i=0;i<this._cardStack.length;i++){var cardInst=this._cardStack[i];if(cardInst.cardDef.name===type&&cardInst.modeDef.name===mode){return i;}}},_findCardUsingImpl:function(impl){for(var i=0;i<this._cardStack.length;i++){var cardInst=this._cardStack[i];if(cardInst.cardImpl===impl)
return i;}},_findCard:function(query,skipFail){var result;if(Array.isArray(query))
result=this._findCardUsingTypeAndMode(query[0],query[1],skipFail);else if(typeof(query)==='number')
result=query;else
result=this._findCardUsingImpl(query);if(result>-1)
return result;else if(!skipFail)
throw new Error('Unable to find card with query:',query);else
return undefined;},hasCard:function(query){return this._findCard(query,true)>-1;},findCardObject:function(query){return this._cardStack[this._findCard(query)];},folderSelector:function(callback){var self=this;App.loader.load(['style/value_selector.css','js/value_selector.js'],function(){if(!self.folderPrompt){var selectorTitle=mozL10n.get('messages-folder-select');self.folderPrompt=new ValueSelector(selectorTitle);}
var folderCardObj=Cards.findCardObject(['folder-picker','navigation']);var folderImpl=folderCardObj.cardImpl;var folders=folderImpl.foldersSlice.items;for(var i=0;i<folders.length;i++){var folder=folders[i];self.folderPrompt.addToList(folder.name,folder.depth,function(folder){return function(){self.folderPrompt.hide();callback(folder);}}(folder));}
self.folderPrompt.show();});},moveToCard:function(query,showMethod){this._showCard(this._findCard(query),showMethod||'animate');},tellCard:function(query,what){var cardIndex=this._findCard(query),cardInst=this._cardStack[cardIndex];if(!('told'in cardInst.cardImpl))
console.warn("Tried to tell a card that's not listening!",query,what);else
cardInst.cardImpl.told(what);},_createMaskForNode:function(domNode,bounds){var anchorIn=this._rootNode,cleanupDivs=[];var uiWidth=this._containerNode.offsetWidth,uiHeight=this._containerNode.offsetHeight;function addMask(left,top,right,bottom){var node=document.createElement('div');node.classList.add('popup-mask');node.style.left=left+'px';node.style.top=top+'px';node.style.width=(right-left+1)+'px';node.style.height=(bottom-top+1)+'px';cleanupDivs.push(node);anchorIn.appendChild(node);}
if(bounds.left>1)
addMask(0,bounds.top,bounds.left-1,bounds.bottom);if(bounds.top>0)
addMask(0,0,uiWidth-1,bounds.top-1);if(bounds.right<uiWidth-1)
addMask(bounds.right+1,bounds.top,uiWidth-1,bounds.bottom);if(bounds.bottom<uiHeight-1)
addMask(0,bounds.bottom+1,uiWidth-1,uiHeight-1);return function(){for(var i=0;i<cleanupDivs.length;i++){anchorIn.removeChild(cleanupDivs[i]);}};},removeCardAndSuccessors:function(cardDomNode,showMethod,numCards,nextCardSpec){if(!this._cardStack.length)
return;var firstIndex,iCard,cardInst;if(cardDomNode===undefined){throw new Error('undefined is not a valid card spec!');}
else if(cardDomNode===null){firstIndex=0;this._zIndex=0;}
else{for(iCard=this._cardStack.length-1;iCard>=0;iCard--){cardInst=this._cardStack[iCard];if(cardInst.domNode===cardDomNode){firstIndex=iCard;break;}}
if(firstIndex===undefined)
throw new Error('No card represented by that DOM node');}
if(!numCards)
numCards=this._cardStack.length-firstIndex;if(showMethod!=='none'){var nextCardIndex=null;if(nextCardSpec)
nextCardIndex=this._findCard(nextCardSpec);else if(this._cardStack.length)
nextCardIndex=Math.min(firstIndex-1,this._cardStack.length-1);this._showCard(nextCardIndex,showMethod,'back');}
if(firstIndex<=this.activeCardIndex){this.activeCardIndex-=numCards;if(this.activeCardIndex<-1){this.activeCardIndex=-1;}}
var deadCardInsts=this._cardStack.splice(firstIndex,numCards);for(iCard=0;iCard<deadCardInsts.length;iCard++){cardInst=deadCardInsts[iCard];try{cardInst.cardImpl.die();}
catch(ex){console.warn('Problem cleaning up card:',ex,'\n',ex.stack);}
switch(showMethod){case'animate':case'immediate':this._animatingDeadDomNodes.push(cardInst.domNode);break;case'none':cardInst.domNode.parentNode.removeChild(cardInst.domNode);break;}}},removeAllCards:function(){return this.removeCardAndSuccessors(null,'none');},_showCard:function(cardIndex,showMethod,navDirection){if(cardIndex===this.activeCardIndex){return;}
if(cardIndex>this._cardStack.length-1){cardIndex=this._cardStack.length-1;}
if(this.activeCardIndex>this._cardStack.length-1){this.activeCardIndex=-1;}
if(this.activeCardIndex===-1){this.activeCardIndex=cardIndex===0?cardIndex:cardIndex-1;}
var cardInst=(cardIndex!==null)?this._cardStack[cardIndex]:null;var beginNode=this._cardStack[this.activeCardIndex].domNode;var endNode=this._cardStack[cardIndex].domNode;var isForward=navDirection==='forward';if(this._cardStack.length===1){this._zIndex=0;}
if(isForward&&endNode.classList.contains('anim-overlay')){beginNode=null;this._zIndex+=10;}
if(beginNode&&beginNode.classList.contains('anim-overlay')){if(isForward){if(showMethod!=='immediate'&&beginNode.classList.contains('anim-vertical')){removeClass(beginNode,'anim-vertical');addClass(beginNode,'disabled-anim-vertical');}}else{endNode=null;this._zIndex-=10;}}
if(endNode&&isForward&&this._zIndex){endNode.style.zIndex=this._zIndex;}
var cardsNode=this._cardsNode;if(showMethod==='immediate'){addClass(beginNode,'no-anim');addClass(endNode,'no-anim');cardsNode.clientWidth;this._eatingEventsUntilNextCard=false;}
else{this._transitionCount=(beginNode&&endNode)?2:1;this._eatingEventsUntilNextCard=true;}
if(this.activeCardIndex===cardIndex){removeClass(beginNode,'before');removeClass(beginNode,'after');addClass(beginNode,'center');}else if(this.activeCardIndex>cardIndex){removeClass(beginNode,'center');addClass(beginNode,'after');removeClass(endNode,'before');addClass(endNode,'center');}else{removeClass(beginNode,'center');addClass(beginNode,'before');removeClass(endNode,'after');addClass(endNode,'center');}
if(showMethod==='immediate'){cardsNode.clientWidth;removeClass(beginNode,'no-anim');removeClass(endNode,'no-anim');}
Toaster.hide();this.activeCardIndex=cardIndex;if(cardInst)
this._trayActive=cardInst.modeDef.tray;},_onTransitionEnd:function(event){if(this._transitionCount>0)
this._transitionCount-=1;if(this._transitionCount===0){if(this._eatingEventsUntilNextCard)
this._eatingEventsUntilNextCard=false;if(this._animatingDeadDomNodes.length){setTimeout(function(){this._animatingDeadDomNodes.forEach(function(domNode){if(domNode.parentNode)
domNode.parentNode.removeChild(domNode);});this._animatingDeadDomNodes=[];}.bind(this),100);}
var endNode=this._cardStack[this.activeCardIndex].domNode;if(endNode.classList.contains('disabled-anim-vertical')){removeClass(endNode,'disabled-anim-vertical');addClass(endNode,'anim-vertical');}
var pendingToaster=Toaster.pendingStack.slice(-1)[0];if(pendingToaster){pendingToaster();Toaster.pendingStack.pop();}
if(this._afterTransitionAction){var afterTransitionAction=this._afterTransitionAction;this._afterTransitionAction=null;afterTransitionAction();}}},eatEventsUntilNextCard:function(){this._eatingEventsUntilNextCard=true;},stopEatingEvents:function(){this._eatingEventsUntilNextCard=false;},assertNoCards:function(){if(this._cardStack.length)
throw new Error('There are '+this._cardStack.length+' cards but'+' there should be ZERO');}};var Toaster={get body(){delete this.body;return this.body=document.querySelector('section[role="status"]');},get text(){delete this.text;return this.text=document.querySelector('section[role="status"] p');},get undoBtn(){delete this.undoBtn;return this.undoBtn=document.querySelector('.toaster-banner-undo');},get retryBtn(){delete this.retryBtn;return this.retryBtn=document.querySelector('.toaster-banner-retry');},undoableOp:null,retryCallback:null,_timeout:5000,_animationHandler:function(){this.body.addEventListener('transitionend',this,false);this.body.classList.add('fadeout');},_listeners:[],pendingStack:[],logMutation:function(undoableOp,pending){if(pending){this.pendingStack.push(this.show.bind(this,'undo',undoableOp));}else{this.show('undo',undoableOp);}},logRetryable:function(retryStringId,retryCallback){this.show('retry',retryStringId,retryCallback);},handleEvent:function(evt){switch(evt.type){case'click':var classList=evt.target.classList;if(classList.contains('toaster-banner-undo')){this.undoableOp.undo();this.hide();}else if(classList.contains('toaster-banner-retry')){if(this.retryCallback)
this.retryCallback();this.hide();}else if(classList.contains('toaster-cancel-btn')){this.hide();}
break;case'transitionend':this.hide();break;}},show:function(type,operation,callback){if(!this.body.classList.contains('collapsed')){this.hide();}
var text,textId,showUndo=false;var undoBtn=this.body.querySelector('.toaster-banner-undo');if(type==='undo'){this.undoableOp=operation;if(!this.undoableOp||this.undoableOp.affectedCount<1){return;}
textId='toaster-message-'+this.undoableOp.operation;text=mozL10n.get(textId,{n:this.undoableOp.affectedCount});showUndo=(this.undoableOp.operation!=='move'&&this.undoableOp.operation!=='delete');}else if(type==='retry'){textId='toaster-retryable-'+operation;text=mozL10n.get(textId);this.retryCallback=callback;}else if(type==='text'){text=operation;}
if(type==='undo'&&showUndo)
this.undoBtn.classList.remove('collapsed');else
this.undoBtn.classList.add('collapsed');if(type==='retry')
this.retryBtn.classList.remove('collapsed');else
this.retryBtn.classList.add('collapsed');this.body.title=type;this.text.textContent=text;this.body.addEventListener('click',this,false);this.body.classList.remove('collapsed');this.fadeTimeout=window.setTimeout(this._animationHandler.bind(this),this._timeout);},hide:function(){this.body.classList.add('collapsed');this.body.classList.remove('fadeout');window.clearTimeout(this.fadeTimeout);this.fadeTimeout=null;this.body.removeEventListener('click',this);this.body.removeEventListener('transitionend',this);this.undoableOp=null;this.retryCallback=null;}};var ConfirmDialog={dialog:null,show:function(dialog,confirm,cancel){this.dialog=dialog;var formSubmit=function(evt){this.hide();switch(evt.explicitOriginalTarget.id){case confirm.id:confirm.handler();break;case cancel.id:if(cancel.handler)
cancel.handler();break;}
return false;};dialog.addEventListener('submit',formSubmit.bind(this));document.body.appendChild(dialog);},hide:function(){document.body.removeChild(this.dialog);}};function prettyFileSize(sizeInBytes){var kilos=Math.ceil(sizeInBytes/1024);return mozL10n.get('attachment-size-kib',{kilobytes:kilos});}
function prettyDate(time){var f=new mozL10n.DateTimeFormat();return f.fromNow(time);}
(function(){var updatePrettyDate=function updatePrettyDate(){var labels=document.querySelectorAll('[data-time]');var i=labels.length;while(i--){labels[i].textContent=prettyDate(labels[i].dataset.time);}};var timer=setInterval(updatePrettyDate,60*1000);window.addEventListener('message',function visibleAppUpdatePrettyDate(evt){var data=evt.data;if(!data||(typeof(data)!=='object')||!('message'in data)||data.message!=='visibilitychange')
return;clearTimeout(timer);if(!data.hidden){updatePrettyDate();timer=setInterval(updatePrettyDate,60*1000);}});})();function FormNavigation(options){function extend(destination,source){for(var property in source)
destination[property]=source[property];return destination;}
if(!options.formElem){throw new Error('The form element should be defined.');}
var self=this;this.options=extend({formElem:null,checkFormValidity:function checkFormValidity(){return self.options.formElem.checkValidity();},onLast:function(){}},options);this.options.formElem.addEventListener('keypress',this.onKeyPress.bind(this));}
FormNavigation.prototype={onKeyPress:function formNav_onKeyPress(event){if(event.keyCode===13){var nextInput=this.focusNextInput(event);if(!nextInput&&this.options.checkFormValidity()){this.options.onLast();}}},focusNextInput:function formNav_focusNextInput(event){var currentInput=event.target;var inputElems=this.options.formElem.getElementsByTagName('input');var currentInputFound=false;for(var i=0;i<inputElems.length;i++){var input=inputElems[i];if(currentInput===input){currentInputFound=true;continue;}else if(!currentInputFound){continue;}
if(input.type==='hidden'||input.type==='button'){continue;}
input.focus();if(document.activeElement!==input){continue;}
return input;}
currentInput.blur();return null;}};;var SCROLL_MIN_BUFFER_SCREENS=2;var SCROLL_MAX_RETENTION_SCREENS=7;var SCROLL_DELAY=50;var MINIMUM_ITEMS_FOR_SCROLL_CALC=10;var MAXIMUM_MS_BETWEEN_SNIPPET_REQUEST=6000;var MAXIMUM_BYTES_PER_MESSAGE_DURING_SCROLL=4*1024;function displaySubject(subjectNode,message){var subject=message.subject&&message.subject.trim();if(subject){subjectNode.textContent=subject;subjectNode.classList.remove('msg-no-subject');}
else{subjectNode.textContent=mozL10n.get('message-no-subject');subjectNode.classList.add('msg-no-subject');}}
function MessageListCard(domNode,mode,args){this.domNode=domNode;this.mode=mode;this.scrollNode=domNode.getElementsByClassName('msg-list-scrollouter')[0];if(mode==='nonsearch')
batchAddClass(domNode,'msg-search-only','collapsed');else
batchAddClass(domNode,'msg-nonsearch-only','collapsed');this.messagesContainer=domNode.getElementsByClassName('msg-messages-container')[0];this.messageEmptyContainer=domNode.getElementsByClassName('msg-list-empty-container')[0];bindContainerClickAndHold(this.messagesContainer,this.onClickMessage.bind(this),this.onHoldMessage.bind(this));this.scrollContainer=domNode.getElementsByClassName('msg-list-scrollouter')[0];this.scrollContainer.addEventListener('scroll',this.onScroll.bind(this),false);this.syncingNode=domNode.getElementsByClassName('msg-messages-syncing')[0];this.syncMoreNode=domNode.getElementsByClassName('msg-messages-sync-more')[0];this.syncMoreNode.addEventListener('click',this.onGetMoreMessages.bind(this),false);this.progressNode=domNode.getElementsByClassName('msg-list-progress')[0];this.progressCandybarTimer=null;this._bound_onCandybarTimeout=this.onCandybarTimeout.bind(this);domNode.getElementsByClassName('msg-folder-list-btn')[0].addEventListener('click',this.onShowFolders.bind(this),false);domNode.getElementsByClassName('msg-compose-btn')[0].addEventListener('click',this.onCompose.bind(this),false);this.toolbar={};this.toolbar.searchBtn=domNode.getElementsByClassName('msg-search-btn')[0];this.toolbar.searchBtn.addEventListener('click',this.onSearchButton.bind(this),false);this.toolbar.editBtn=domNode.getElementsByClassName('msg-edit-btn')[0];this.toolbar.editBtn.addEventListener('click',this.setEditMode.bind(this,true),false);domNode.getElementsByClassName('msg-refresh-btn')[0].addEventListener('click',this.onRefresh.bind(this),false);domNode.getElementsByClassName('msg-listedit-cancel-btn')[0].addEventListener('click',this.setEditMode.bind(this,false),false);domNode.getElementsByClassName('msg-star-btn')[0].addEventListener('click',this.onStarMessages.bind(this,true),false);domNode.getElementsByClassName('msg-mark-read-btn')[0].addEventListener('click',this.onMarkMessagesRead.bind(this,true),false);domNode.getElementsByClassName('msg-delete-btn')[0].addEventListener('click',this.onDeleteMessages.bind(this,true),false);domNode.getElementsByClassName('msg-move-btn')[0].addEventListener('click',this.onMoveMessages.bind(this,true),false);if(mode==='nonsearch'){domNode.getElementsByClassName('msg-search-text-tease')[0].addEventListener('focus',this.onSearchButton.bind(this),false);}
else if(mode==='search'){domNode.getElementsByClassName('msg-search-cancel')[0].addEventListener('click',this.onCancelSearch.bind(this),false);bindContainerHandler(domNode.getElementsByClassName('filter')[0],'click',this.onSearchFilterClick.bind(this));this.searchInput=domNode.getElementsByClassName('msg-search-text')[0];this.searchInput.addEventListener('input',this.onSearchTextChange.bind(this),false);}
this._onScroll=this._onScroll.bind(this);this.editMode=false;this.selectedMessages=null;this.curFolder=null;this.messagesSlice=null;this._boundSliceRequestComplete=this.onSliceRequestComplete.bind(this);if(mode=='nonsearch')
this.showFolder(args.folder);else
this.showSearch(args.folder,args.phrase||'',args.filter||'all');}
MessageListCard.prototype={PROGRESS_CANDYBAR_TIMEOUT_MS:2000,postInsert:function(){this._hideSearchBoxByScrolling();if(this.mode==='search')
this.searchInput.focus();},onSearchButton:function(){Cards.pushCard('message-list','search','animate',{folder:this.curFolder});},setEditMode:function(editMode){var domNode=this.domNode;var normalHeader=domNode.getElementsByClassName('msg-list-header')[0],searchHeader=domNode.getElementsByClassName('msg-search-header')[0],editHeader=domNode.getElementsByClassName('msg-listedit-header')[0],normalToolbar=domNode.getElementsByClassName('msg-list-action-toolbar')[0],editToolbar=domNode.getElementsByClassName('msg-listedit-action-toolbar')[0];this.editMode=editMode;if(editMode){normalHeader.classList.add('collapsed');searchHeader.classList.add('collapsed');normalToolbar.classList.add('collapsed');editHeader.classList.remove('collapsed');editToolbar.classList.remove('collapsed');this.messagesContainer.classList.add('show-edit');this.selectedMessages=[];var cbs=this.messagesContainer.querySelectorAll('input[type=checkbox]');for(var i=0;i<cbs.length;i++){cbs[i].checked=false;}
this.selectedMessagesUpdated();}
else{if(this.mode==='nonsearch')
normalHeader.classList.remove('collapsed');else
searchHeader.classList.remove('collapsed');normalToolbar.classList.remove('collapsed');editHeader.classList.add('collapsed');editToolbar.classList.add('collapsed');this.messagesContainer.classList.remove('show-edit');var selectedMsgNodes=domNode.getElementsByClassName('msg-header-item-selected');for(var i=selectedMsgNodes.length-1;i>=0;i--){selectedMsgNodes[i].classList.remove('msg-header-item-selected');}
this.selectedMessages=null;}},selectedMessagesUpdated:function(){var headerNode=this.domNode.getElementsByClassName('msg-listedit-header-label')[0];headerNode.textContent=mozL10n.get('message-multiedit-header',{n:this.selectedMessages.length});var starBtn=this.domNode.getElementsByClassName('msg-star-btn')[0],readBtn=this.domNode.getElementsByClassName('msg-mark-read-btn')[0];var numStarred=0,numRead=0;for(var i=0;i<this.selectedMessages.length;i++){var msg=this.selectedMessages[i];if(msg.isStarred)
numStarred++;if(msg.isRead)
numRead++;}
this.setAsStarred=!(numStarred&&numStarred===this.selectedMessages.length);this.setAsRead=(this.selectedMessages.length&&numRead===0);if(!this.setAsStarred)
starBtn.classList.add('msg-btn-active');else
starBtn.classList.remove('msg-btn-active');if(this.setAsRead)
readBtn.classList.add('msg-btn-active');else
readBtn.classList.remove('msg-btn-active');},_hideSearchBoxByScrolling:function(){var searchBar=this.domNode.getElementsByClassName('msg-search-tease-bar')[0];this.scrollNode.scrollTop=searchBar.offsetHeight;},onShowFolders:function(){Cards.moveToCard(['folder-picker','navigation']);},onCompose:function(){var composer=MailAPI.beginMessageComposition(null,this.curFolder,null,function composerReady(){Cards.pushCard('compose','default','animate',{composer:composer});});},showFolder:function(folder,forceNewSlice){if(folder===this.curFolder&&!forceNewSlice)
return false;if(this.messagesSlice){this.messagesSlice.die();this.messagesSlice=null;this.messagesContainer.innerHTML='';}
this.curFolder=folder;this.domNode.getElementsByClassName('msg-list-header-folder-label')[0].textContent=folder.name;this.hideEmptyLayout();this.messagesSlice=MailAPI.viewFolderMessages(folder);this.messagesSlice.onsplice=this.onMessagesSplice.bind(this);this.messagesSlice.onchange=this.updateMessageDom.bind(this,false);this.messagesSlice.onstatus=this.onStatusChange.bind(this);this.messagesSlice.oncomplete=this._boundSliceRequestComplete;return true;},showSearch:function(folder,phrase,filter){console.log('sf: showSearch. phrase:',phrase,phrase.length);var tab=this.domNode.getElementsByClassName('filter')[0];var nodes=tab.getElementsByClassName('msg-search-filter');if(this.messagesSlice){this.messagesSlice.die();this.messagesSlice=null;this.messagesContainer.innerHTML='';}
this.curFolder=folder;this.curPhrase=phrase;this.curFilter=filter;for(var i=0;i<nodes.length;i++){if(nodes[i].dataset.filter!=this.curFilter){nodes[i].setAttribute('aria-selected','false');continue;}
nodes[i].setAttribute('aria-selected','true');}
if(phrase.length<1)
return false;this.messagesSlice=MailAPI.searchFolderMessages(folder,phrase,{author:filter==='all'||filter==='author',recipients:filter==='all'||filter==='recipients',subject:filter==='all'||filter==='subject',body:filter==='all'||filter==='body'});this.messagesSlice.onsplice=this.onMessagesSplice.bind(this);this.messagesSlice.onchange=this.updateMatchedMessageDom.bind(this,false);this.messagesSlice.onstatus=this.onStatusChange.bind(this);this.messagesSlice.oncomplete=this._boundSliceRequestComplete;return true;},onSearchFilterClick:function(filterNode,event){this.showSearch(this.curFolder,this.searchInput.value,filterNode.dataset.filter);},onSearchTextChange:function(event){console.log('sf: typed, now:',this.searchInput.value);this.showSearch(this.curFolder,this.searchInput.value,this.curFilter);},onCancelSearch:function(event){try{if(this.messagesSlice)
this.messagesSlice.die();}
catch(ex){console.error('problem killing slice:',ex,'\n',ex.stack);}
this.messagesSlice=null;Cards.removeCardAndSuccessors(this.domNode,'animate');},onGetMoreMessages:function(){this.messagesSlice.requestGrowth(1,true);this.syncMoreNode.classList.add('collapsed');},onStatusChange:function(newStatus){switch(newStatus){case'synchronizing':case'syncblocked':this.syncingNode.classList.remove('collapsed');this.syncMoreNode.classList.add('collapsed');this.hideEmptyLayout();this.progressNode.value=this.messagesSlice?this.messagesSlice.syncProgress:0;this.progressNode.classList.remove('pack-activity');this.progressNode.classList.remove('hidden');if(this.progressCandybarTimer)
window.clearTimeout(this.progressCandybarTimer);this.progressCandybarTimer=window.setTimeout(this._bound_onCandybarTimeout,this.PROGRESS_CANDYBAR_TIMEOUT_MS);break;case'syncfailed':Toaster.logRetryable(newStatus,this.onRefresh.bind(this));case'synced':this.syncingNode.classList.add('collapsed');this.progressNode.classList.remove('pack-activity');this.progressNode.classList.add('hidden');if(this.progressCandybarTimer){window.clearTimeout(this.progressCandybarTimer);this.progressCandybarTimer=null;}
break;}},onCandybarTimeout:function(){this.progressNode.classList.add('pack-activity');},showEmptyLayout:function(){var text=this.domNode.getElementsByClassName('msg-list-empty-message-text')[0];text.textContent=this.mode=='search'?mozL10n.get('messages-search-empty'):mozL10n.get('messages-folder-empty');this.messageEmptyContainer.classList.remove('collapsed');this.toolbar.editBtn.classList.add('disabled');this.toolbar.searchBtn.classList.add('disabled');this._hideSearchBoxByScrolling();},hideEmptyLayout:function(){this.messageEmptyContainer.classList.add('collapsed');this.toolbar.editBtn.classList.remove('disabled');this.toolbar.searchBtn.classList.remove('disabled');},onSliceRequestComplete:function(){this.messagesSlice.oncomplete=this._boundSliceRequestComplete;if(this.messagesSlice.userCanGrowDownwards)
this.syncMoreNode.classList.remove('collapsed');else
this.syncMoreNode.classList.add('collapsed');if(this.messagesSlice.items.length===0){this.showEmptyLayout();}
this._onScroll(null);},onScroll:function(evt){if(this._pendingScrollEvent){return;}
this._pendingScrollEvent=true;this._scrollTimer=setTimeout(this._onScroll,SCROLL_DELAY,evt);},_onScroll:function(event){if(this._pendingScrollEvent){this._pendingScrollEvent=false;}
if(!this.messagesSlice||this.messagesSlice.pendingRequestCount)
return;if(!this._hasSnippetRequest()){this._requestSnippets();}
var curScrollTop=this.scrollContainer.scrollTop,viewHeight=this.scrollContainer.clientHeight;var preScreens=curScrollTop/viewHeight,postScreens=(this.scrollContainer.scrollHeight-
(curScrollTop+viewHeight))/viewHeight;var shrinkLowIncl=0,shrinkHighIncl=this.messagesSlice.items.length-1,messageNode=null,targOff;if(preScreens<SCROLL_MIN_BUFFER_SCREENS&&!this.messagesSlice.atTop){this.messagesSlice.requestGrowth(-1);return;}
else if(preScreens>SCROLL_MAX_RETENTION_SCREENS){targOff=curScrollTop-
(viewHeight*(SCROLL_MAX_RETENTION_SCREENS-1));for(messageNode=this.messagesContainer.firstElementChild;messageNode.offsetTop+messageNode.clientHeight<targOff;messageNode=messageNode.nextElementSibling){shrinkLowIncl++;}}
if(postScreens<SCROLL_MIN_BUFFER_SCREENS&&!this.messagesSlice.atBottom){this.messagesSlice.requestGrowth(1);}
else if(postScreens>SCROLL_MAX_RETENTION_SCREENS){targOff=curScrollTop+
this.scrollContainer.clientHeight+
(viewHeight*(SCROLL_MAX_RETENTION_SCREENS-1));for(messageNode=this.messagesContainer.lastElementChild;messageNode.offsetTop>targOff;messageNode=messageNode.previousElementSibling){shrinkHighIncl--;}}
if(shrinkLowIncl!==0||shrinkHighIncl!==this.messagesSlice.items.length-1){this.messagesSlice.requestShrinkage(shrinkLowIncl,shrinkHighIncl);}},_hasSnippetRequest:function(){var max=MAXIMUM_MS_BETWEEN_SNIPPET_REQUEST;var now=Date.now();var beforeTimeout=(this._lastSnippetRequest+max)>now;if(this._snippetRequestPending&&beforeTimeout){return true;}
return false;},_pendingSnippetRequest:function(){this._snippetRequestPending=true;this._lastSnippetRequest=Date.now();},_clearSnippetRequest:function(){this._snippetRequestPending=false;},_requestSnippets:function(){var items=this.messagesSlice.items;var len=items.length;if(!len)
return;var clearSnippets=this._clearSnippetRequest.bind(this);var options={maximumBytesToFetch:MAXIMUM_BYTES_PER_MESSAGE_DURING_SCROLL};if(len<MINIMUM_ITEMS_FOR_SCROLL_CALC){this._pendingSnippetRequest();this.messagesSlice.maybeRequestBodies(0,9,options,clearSnippets);return;}
if(!this._scrollContainerOffset){this._scrollContainerRect=this.scrollContainer.getBoundingClientRect();}
var constOffset=this._scrollContainerRect.top;var topOffset=(items[0].element.getBoundingClientRect().top-constOffset);var distance=this._distanceBetweenMessages;if(!distance){this._distanceBetweenMessages=distance=Math.abs(topOffset-
(items[1].element.getBoundingClientRect().top-constOffset));}
var startOffset=Math.floor(Math.abs(topOffset/distance));this._snippetsPerScrollTick=(this._snippetsPerScrollTick||Math.ceil(this._scrollContainerRect.height/distance));this._pendingSnippetRequest();this.messagesSlice.maybeRequestBodies(startOffset,startOffset+this._snippetsPerScrollTick,options,clearSnippets);},onMessagesSplice:function(index,howMany,addedItems,requested,moreExpected){var prevHeight;if(howMany){prevHeight=null;if(this.messagesSlice.items[index].element.offsetTop<this.scrollContainer.scrollTop+this.messagesContainer.offsetTop){prevHeight=this.messagesContainer.clientHeight;}
for(var i=index+howMany-1;i>=index;i--){var message=this.messagesSlice.items[i];message.element.parentNode.removeChild(message.element);}
if(prevHeight!==null){this.scrollContainer.scrollTop-=(prevHeight-this.messagesContainer.clientHeight);}
if(this.messagesContainer.children.length===0){this.showEmptyLayout();}}
var insertBuddy,self=this;if(index>=this.messagesContainer.childElementCount)
insertBuddy=null;else
insertBuddy=this.messagesContainer.children[index];if(insertBuddy&&(insertBuddy.offsetTop<this.scrollContainer.scrollTop+this.messagesContainer.offsetTop))
prevHeight=this.messagesContainer.clientHeight;else
prevHeight=null;if(addedItems.length>0){this.hideEmptyLayout();}
addedItems.forEach(function(message){var domMessage;domMessage=message.element=msgNodes['header-item'].cloneNode(true);if(self.mode==='nonsearch'){domMessage.message=message;self.updateMessageDom(true,message);}
else{domMessage.message=message.header;self.updateMatchedMessageDom(true,message);}
self.messagesContainer.insertBefore(domMessage,insertBuddy);});if(prevHeight){this.scrollContainer.scrollTop+=(this.messagesContainer.clientHeight-prevHeight);}},updateMessageDom:function(firstTime,message){var msgNode=message.element;var dateNode=msgNode.getElementsByClassName('msg-header-date')[0];if(firstTime){msgNode.getElementsByClassName('msg-header-author')[0].textContent=message.author.name||message.author.address;dateNode.dataset.time=message.date.valueOf();dateNode.textContent=prettyDate(message.date);displaySubject(msgNode.getElementsByClassName('msg-header-subject')[0],message);if(message.hasAttachments)
msgNode.getElementsByClassName('msg-header-attachments')[0].classList.add('msg-header-attachments-yes');}
msgNode.getElementsByClassName('msg-header-snippet')[0].textContent=message.snippet;var unreadNode=msgNode.getElementsByClassName('msg-header-unread-section')[0];if(message.isRead){unreadNode.classList.remove('msg-header-unread-section-unread');dateNode.classList.remove('msg-header-date-unread');}
else{unreadNode.classList.add('msg-header-unread-section-unread');dateNode.classList.add('msg-header-date-unread');}
var starNode=msgNode.getElementsByClassName('msg-header-star')[0];if(message.isStarred)
starNode.classList.add('msg-header-star-starred');else
starNode.classList.remove('msg-header-star-starred');},updateMatchedMessageDom:function(firstTime,matchedHeader){var msgNode=matchedHeader.element,matches=matchedHeader.matches,message=matchedHeader.header;var dateNode=msgNode.getElementsByClassName('msg-header-date')[0];if(firstTime){var authorNode=msgNode.getElementsByClassName('msg-header-author')[0];if(matches.author)
appendMatchItemTo(matches.author,authorNode);else
authorNode.textContent=message.author.name||message.author.address;dateNode.dataset.time=message.date.valueOf();dateNode.textContent=prettyDate(message.date);var subjectNode=msgNode.getElementsByClassName('msg-header-subject')[0];if(matches.subject)
appendMatchItemTo(matches.subject[0],subjectNode);else
displaySubject(subjectNode,message);var snippetNode=msgNode.getElementsByClassName('msg-header-snippet')[0];if(matches.body)
appendMatchItemTo(matches.body[0],snippetNode);else
snippetNode.textContent=message.snippet;if(message.hasAttachments)
msgNode.getElementsByClassName('msg-header-attachments')[0].classList.add('msg-header-attachments-yes');}
var unreadNode=msgNode.getElementsByClassName('msg-header-unread-section')[0];if(message.isRead){unreadNode.classList.remove('msg-header-unread-section-unread');dateNode.classList.remove('msg-header-date-unread');}
else{unreadNode.classList.add('msg-header-unread-section-unread');dateNode.classList.add('msg-header-date-unread');}
var starNode=msgNode.getElementsByClassName('msg-header-star')[0];if(message.isStarred)
starNode.classList.add('msg-header-star-starred');else
starNode.classList.remove('msg-header-star-starred');},onClickMessage:function(messageNode,event){var header=messageNode.message;if(this.editMode){var idx=this.selectedMessages.indexOf(header);var cb=messageNode.querySelector('input[type=checkbox]');if(idx!==-1){this.selectedMessages.splice(idx,1);cb.checked=false;}
else{this.selectedMessages.push(header);cb.checked=true;}
this.selectedMessagesUpdated();return;}
Cards.pushCard('message-reader','default','animate',{header:header});},onHoldMessage:function(messageNode,event){this.setEditMode(true);},onRefresh:function(){switch(this.messagesSlice.status){case'new':case'synchronizing':break;case'synced':this.messagesSlice.refresh();break;case'syncfailed':if(this.messagesSlice.items.length)
this.messagesSlice.refresh();else
this.showFolder(this.curFolder,true);break;}},onStarMessages:function(){var op=MailAPI.markMessagesStarred(this.selectedMessages,this.setAsStarred);this.setEditMode(false);Toaster.logMutation(op);},onMarkMessagesRead:function(){var op=MailAPI.markMessagesRead(this.selectedMessages,this.setAsRead);this.setEditMode(false);Toaster.logMutation(op);},onDeleteMessages:function(){if(this.selectedMessages.length===0)
return;var dialog=msgNodes['delete-confirm'].cloneNode(true);var content=dialog.getElementsByTagName('p')[0];content.textContent=mozL10n.get('message-multiedit-delete-confirm',{n:this.selectedMessages.length});ConfirmDialog.show(dialog,{id:'msg-delete-ok',handler:function(){var op=MailAPI.deleteMessages(this.selectedMessages);Toaster.logMutation(op);this.setEditMode(false);}.bind(this)},{id:'msg-delete-cancel',handler:null});},onMoveMessages:function(){Cards.folderSelector(function(folder){var op=MailAPI.moveMessages(this.selectedMessages,folder);Toaster.logMutation(op);this.setEditMode(false);}.bind(this));},told:function(args){if(this.showFolder(args.folder)){this._hideSearchBoxByScrolling();}},die:function(){if(this.messagesSlice){this.messagesSlice.die();this.messagesSlice=null;}}};Cards.defineCard({name:'message-list',modes:{nonsearch:{tray:false},search:{tray:false}},constructor:MessageListCard});var CONTENT_TYPES_TO_CLASS_NAMES=[null,'msg-body-content','msg-body-signature','msg-body-leadin',null,'msg-body-disclaimer','msg-body-list','msg-body-product','msg-body-ads'];var CONTENT_QUOTE_CLASS_NAMES=['msg-body-q1','msg-body-q2','msg-body-q3','msg-body-q4','msg-body-q5','msg-body-q6','msg-body-q7','msg-body-q8','msg-body-q9'];var MAX_QUOTE_CLASS_NAME='msg-body-qmax';function MessageReaderCard(domNode,mode,args){this.domNode=domNode;this.header=args.header;this.htmlBodyNodes=[];domNode.getElementsByClassName('msg-back-btn')[0].addEventListener('click',this.onBack.bind(this,false));domNode.getElementsByClassName('msg-reply-btn')[0].addEventListener('click',this.onReply.bind(this,false));domNode.getElementsByClassName('msg-reply-all-btn')[0].addEventListener('click',this.onReplyAll.bind(this,false));domNode.getElementsByClassName('msg-delete-btn')[0].addEventListener('click',this.onDelete.bind(this),false);domNode.getElementsByClassName('msg-star-btn')[0].addEventListener('click',this.onToggleStar.bind(this),false);domNode.getElementsByClassName('msg-move-btn')[0].addEventListener('click',this.onMove.bind(this),false);domNode.getElementsByClassName('msg-forward-btn')[0].addEventListener('click',this.onForward.bind(this),false);this.scrollContainer=domNode.getElementsByClassName('scrollregion-below-header')[0];this.envelopeNode=domNode.getElementsByClassName('msg-envelope-bar')[0];this.envelopeNode.addEventListener('click',this.onEnvelopeClick.bind(this),false);this.envelopeDetailsNode=domNode.getElementsByClassName('msg-envelope-details')[0];domNode.getElementsByClassName('msg-reader-load-infobar')[0].addEventListener('click',this.onLoadBarClick.bind(this),false);if(!this.header.isRead)
this.header.setRead(true);if(this.header.isStarred)
domNode.getElementsByClassName('msg-star-btn')[0].classList.add('msg-btn-active');this.handleBodyChange=this.handleBodyChange.bind(this);}
MessageReaderCard.prototype={postInsert:function(){this.buildHeaderDom(this.domNode);var self=this;this.header.getBody({downloadBodyReps:true},function(body){self.body=body;body.onchange=self.handleBodyChange;if(body.bodyRepsDownloaded){return App.loader.load('js/iframe-shims.js',self.buildBodyDom.bind(self));}});},handleBodyChange:function(evt){switch(evt.changeType){case'bodyReps':if(this.body.bodyRepsDownloaded){App.loader.load('js/iframe-shims.js',this.buildBodyDom.bind(this));}
break;}},onBack:function(event){Cards.removeCardAndSuccessors(this.domNode,'animate');},onReply:function(event){Cards.eatEventsUntilNextCard();var composer=this.header.replyToMessage(null,function(){Cards.pushCard('compose','default','animate',{composer:composer});});},onReplyAll:function(event){Cards.eatEventsUntilNextCard();var composer=this.header.replyToMessage('all',function(){Cards.pushCard('compose','default','animate',{composer:composer});});},onForward:function(event){Cards.eatEventsUntilNextCard();var composer=this.header.forwardMessage('inline',function(){Cards.pushCard('compose','default','animate',{composer:composer});});},onDelete:function(){var dialog=msgNodes['delete-confirm'].cloneNode(true);ConfirmDialog.show(dialog,{id:'msg-delete-ok',handler:function(){var op=this.header.deleteMessage();Toaster.logMutation(op,true);Cards.removeCardAndSuccessors(this.domNode,'animate');}.bind(this)},{id:'msg-delete-cancel',handler:null});},onToggleStar:function(){var button=this.domNode.getElementsByClassName('msg-star-btn')[0];if(!this.header.isStarred)
button.classList.add('msg-btn-active');else
button.classList.remove('msg-btn-active');this.header.setStarred(!this.header.isStarred);},onMove:function(){Cards.folderSelector(function(folder){var op=this.header.moveMessage(folder);Toaster.logMutation(op,true);Cards.removeCardAndSuccessors(this.domNode,'animate');}.bind(this));},onEnvelopeClick:function(event){var target=event.target;if(!target.classList.contains('msg-peep-bubble')){return;}
this.onPeepClick(target);},onPeepClick:function(target){var contents=msgNodes['contact-menu'].cloneNode(true);var email=target.getAttribute('data-email');contents.getElementsByTagName('header')[0].textContent=email;document.body.appendChild(contents);var formSubmit=(function(evt){document.body.removeChild(contents);switch(evt.explicitOriginalTarget.className){case'msg-contact-menu-view':try{var activity=new MozActivity({name:'new',data:{type:'webcontacts/contact',params:{'email':email}}});}catch(e){console.log('WebActivities unavailable? : '+e);}
break;case'msg-contact-menu-reply':var composer=this.header.replyToMessage(null,function(){Cards.pushCard('compose','default','animate',{composer:composer});});break;}
return false;}).bind(this);contents.addEventListener('submit',formSubmit);},onLoadBarClick:function(event){var self=this;var loadBar=this.domNode.getElementsByClassName('msg-reader-load-infobar')[0];if(!this.body.embeddedImagesDownloaded){this.body.downloadEmbeddedImages(function(){if(!self.domNode)
return;for(var i=0;i<self.htmlBodyNodes.length;i++){self.body.showEmbeddedImages(self.htmlBodyNodes[i],self.iframeResizeHandler);}});loadBar.classList.add('collapsed');}
else{for(var i=0;i<this.htmlBodyNodes.length;i++){this.body.showExternalImages(this.htmlBodyNodes[i],this.iframeResizeHandler);}
loadBar.classList.add('collapsed');}},getAttachmentBlob:function(attachment,callback){try{var storageType=attachment._file[0];var filename=attachment._file[1];var storage=navigator.getDeviceStorage(storageType);var getreq=storage.get(filename);getreq.onerror=function(){console.warn('Could not open attachment file: ',filename,getreq.error.name);};getreq.onsuccess=function(){var blob=getreq.result;callback(blob);};}catch(ex){console.warn('Exception getting attachment from device storage:',attachment._file,'\n',ex,'\n',ex.stack);}},onDownloadAttachmentClick:function(node,attachment){node.setAttribute('state','downloading');attachment.download(function downloaded(){if(!attachment._file)
return;node.setAttribute('state','downloaded');});},onViewAttachmentClick:function(node,attachment){console.log('trying to open',attachment._file,'type:',attachment.mimetype);if(!attachment._file)
return;if(attachment.isDownloaded){this.getAttachmentBlob(attachment,function(blob){try{if(!blob){throw new Error('Blob does not exist');}
var activity=new MozActivity({name:'open',data:{type:attachment.mimetype,blob:blob}});activity.onerror=function(){console.warn('Problem with "open" activity',activity.error.name);};activity.onsuccess=function(){console.log('"open" activity allegedly succeeded');};}
catch(ex){console.warn('Problem creating "open" activity:',ex,'\n',ex.stack);}});}},onHyperlinkClick:function(event,linkNode,linkUrl,linkText){var dialog=msgNodes['browse-confirm'].cloneNode(true);var content=dialog.getElementsByTagName('p')[0];content.textContent=mozL10n.get('browse-to-url-prompt',{url:linkUrl});ConfirmDialog.show(dialog,{id:'msg-browse-ok',handler:function(){window.open(linkUrl,'_blank');}.bind(this)},{id:'msg-browse-cancel',handler:null});},_populatePlaintextBodyNode:function(bodyNode,rep){for(var i=0;i<rep.length;i+=2){var node=document.createElement('div'),cname;var etype=rep[i]&0xf,rtype=null;if(etype===0x4){var qdepth=(((rep[i]>>8)&0xff)+1);if(qdepth>8)
cname=MAX_QUOTE_CLASS_NAME;else
cname=CONTENT_QUOTE_CLASS_NAMES[qdepth];}
else{cname=CONTENT_TYPES_TO_CLASS_NAMES[etype];}
if(cname)
node.setAttribute('class',cname);var subnodes=MailAPI.utils.linkifyPlain(rep[i+1],document);for(var iNode=0;iNode<subnodes.length;iNode++){node.appendChild(subnodes[iNode]);}
bodyNode.appendChild(node);}},buildHeaderDom:function(domNode){var header=this.header,body=this.body;function addHeaderEmails(lineClass,peeps){var lineNode=domNode.getElementsByClassName(lineClass)[0];if(!peeps||!peeps.length){lineNode.classList.add('collapsed');return;}
var peepTemplate=msgNodes['peep-bubble'],contentTemplate=peepTemplate.getElementsByClassName('msg-peep-content')[0];if(lineClass=='msg-envelope-from-line'){var peep=peeps[0];contentTemplate.textContent=peep.address||peep.name;peepTemplate.setAttribute('data-email',peep.address);if(peep.address){contentTemplate.classList.add('msg-peep-address');}
lineNode.appendChild(peepTemplate.cloneNode(true));domNode.getElementsByClassName('msg-reader-header-label')[0].textContent=peep.name||peep.address;return;}
for(var i=0;i<peeps.length;i++){var peep=peeps[i];contentTemplate.textContent=peep.name||peep.address;peepTemplate.setAttribute('data-email',peep.address);if(!peep.name&&peep.address){contentTemplate.classList.add('msg-peep-address');}else{contentTemplate.classList.remove('msg-peep-address');}
lineNode.appendChild(peepTemplate.cloneNode(true));}}
addHeaderEmails('msg-envelope-from-line',[header.author]);addHeaderEmails('msg-envelope-to-line',header.to);addHeaderEmails('msg-envelope-cc-line',header.cc);addHeaderEmails('msg-envelope-bcc-line',header.bcc);var dateNode=domNode.getElementsByClassName('msg-envelope-date')[0];dateNode.dataset.time=header.date.valueOf();dateNode.textContent=prettyDate(header.date);displaySubject(domNode.getElementsByClassName('msg-envelope-subject')[0],header);},buildBodyDom:function(){var body=this.body;var domNode=this.domNode;var rootBodyNode=domNode.getElementsByClassName('msg-body-container')[0],reps=body.bodyReps,hasExternalImages=false,showEmbeddedImages=body.embeddedImageCount&&body.embeddedImagesDownloaded;bindSanitizedClickHandler(rootBodyNode,this.onHyperlinkClick.bind(this),rootBodyNode,null);for(var iRep=0;iRep<reps.length;iRep++){var rep=reps[iRep];if(rep.type==='plain'){this._populatePlaintextBodyNode(rootBodyNode,rep.content);}
else if(rep.type==='html'){var iframeShim=createAndInsertIframeForContent(rep.content,this.scrollContainer,rootBodyNode,null,'interactive',this.onHyperlinkClick.bind(this));var iframe=iframeShim.iframe;var bodyNode=iframe.contentDocument.body;this.iframeResizeHandler=iframeShim.resizeHandler;MailAPI.utils.linkifyHTML(iframe.contentDocument);this.htmlBodyNodes.push(bodyNode);if(body.checkForExternalImages(bodyNode))
hasExternalImages=true;if(showEmbeddedImages)
body.showEmbeddedImages(bodyNode);}
if(iRep===0){var progressNode=rootBodyNode.querySelector('progress');if(progressNode){progressNode.parentNode.removeChild(progressNode);}}}
var loadBar=domNode.getElementsByClassName('msg-reader-load-infobar')[0];if(body.embeddedImageCount&&!body.embeddedImagesDownloaded){loadBar.classList.remove('collapsed');loadBar.textContent=mozL10n.get('message-download-images',{n:body.embeddedImageCount});}
else if(hasExternalImages){loadBar.classList.remove('collapsed');loadBar.textContent=mozL10n.get('message-show-external-images');}
else{loadBar.classList.add('collapsed');}
var attachmentsContainer=domNode.getElementsByClassName('msg-attachments-container')[0];if(body.attachments&&body.attachments.length){var attTemplate=msgNodes['attachment-item'],filenameTemplate=attTemplate.getElementsByClassName('msg-attachment-filename')[0],filesizeTemplate=attTemplate.getElementsByClassName('msg-attachment-filesize')[0];for(var iAttach=0;iAttach<body.attachments.length;iAttach++){var attachment=body.attachments[iAttach],state;if(attachment.isDownloaded)
state='downloaded';else if(/^image\//.test(attachment.mimetype))
state='downloadable';else
state='nodownload';attTemplate.setAttribute('state',state);filenameTemplate.textContent=attachment.filename;filesizeTemplate.textContent=prettyFileSize(attachment.sizeEstimateInBytes);var attachmentNode=attTemplate.cloneNode(true);attachmentsContainer.appendChild(attachmentNode);attachmentNode.getElementsByClassName('msg-attachment-download')[0].addEventListener('click',this.onDownloadAttachmentClick.bind(this,attachmentNode,attachment));attachmentNode.getElementsByClassName('msg-attachment-view')[0].addEventListener('click',this.onViewAttachmentClick.bind(this,attachmentNode,attachment));}}
else{attachmentsContainer.classList.add('collapsed');}},die:function(){if(this.body){this.body.die();this.body=null;}
this.domNode=null;}};Cards.defineCardWithDefaultMode('message-reader',{tray:false},MessageReaderCard);;var FOLDER_DEPTH_CLASSES=['fld-folder-depth0','fld-folder-depth1','fld-folder-depth2','fld-folder-depth3','fld-folder-depth4','fld-folder-depth5','fld-folder-depthmax'];function FolderPickerCard(domNode,mode,args){this.domNode=domNode;this.foldersSlice=args.foldersSlice;this.foldersSlice.onsplice=this.onFoldersSplice.bind(this);this.foldersSlice.onchange=this.onFoldersChange.bind(this);this.curAccount=args.curAccount;this.curFolder=args.curFolder;this.mostRecentSyncTimestamp=0;this.acctsSlice=args.acctsSlice;this.foldersContainer=domNode.getElementsByClassName('fld-folders-container')[0];bindContainerHandler(this.foldersContainer,'click',this.onClickFolder.bind(this));this.accountButton=domNode.getElementsByClassName('fld-accounts-btn')[0];this.accountButton.addEventListener('click',this.onShowAccounts.bind(this),false);domNode.getElementsByClassName('fld-nav-settings-btn')[0].addEventListener('click',this.onShowSettings.bind(this),false);this.toolbarAccountProblemNode=domNode.getElementsByClassName('fld-nav-account-problem')[0];this.lastSyncedAtNode=domNode.getElementsByClassName('fld-nav-last-synced-value')[0];this.updateSelfDom();this.onFoldersSplice(0,0,this.foldersSlice.items,true,false);}
FolderPickerCard.prototype={onShowSettings:function(){Cards.pushCard('settings-main','default','animate',{},'left');},updateAccount:function(account){var oldAccount=this.curAccount;this.mostRecentSyncTimestamp=0;if(oldAccount!==account){this.curAccount=account;this.domNode.getElementsByClassName('fld-folders-header-account-label')[0].textContent=account.name;this.foldersSlice.die();this.foldersContainer.innerHTML='';this.lastSyncedAtNode.textContent='';this.lastSyncedAtNode.removeAttribute('data-time');Cards.eatEventsUntilNextCard();this.foldersSlice=MailAPI.viewFolders('account',account);this.foldersSlice.onsplice=this.onFoldersSplice.bind(this);this.foldersSlice.onchange=this.onFoldersChange.bind(this);this.curFolder=null;}},onShowAccounts:function(){Cards.pushCard('account-picker','navigation','animate',{acctsSlice:this.acctsSlice,curAccount:this.curAccount},'left');},onFoldersSplice:function(index,howMany,addedItems,requested,moreExpected){if(!this.curFolder&&!moreExpected){Cards.moveToCard(this);this.curFolder=this.foldersSlice.getFirstFolderWithType('inbox',addedItems);this._showFolder(this.curFolder);}
var foldersContainer=this.foldersContainer;var folder;if(howMany){for(var i=index+howMany-1;i>=index;i--){folder=this.foldersSlice.items[i];foldersContainer.removeChild(folder.element);}}
var dirtySyncTime=false;var insertBuddy=(index>=foldersContainer.childElementCount)?null:foldersContainer.children[index],self=this;addedItems.forEach(function(folder){var folderNode=folder.element=fldNodes['folder-item'].cloneNode(true);folderNode.folder=folder;self.updateFolderDom(folder,true);foldersContainer.insertBefore(folderNode,insertBuddy);if(this.mostRecentSyncTimestamp<folder.lastSyncedAt){this.mostRecentSyncTimestamp=folder.lastSyncedAt;dirtySyncTime=true;}});if(dirtySyncTime)
this.updateLastSyncedUI();},onFoldersChange:function(folder){if(this.mostRecentSyncTimestamp<folder.lastSyncedAt){this.mostRecentSyncTimestamp=folder.lastSyncedAt;this.updateLastSyncedUI();}},updateLastSyncedUI:function(){if(this.mostRecentSyncTimestamp){this.lastSyncedAtNode.dataset.time=this.mostRecentSyncTimestamp.valueOf();this.lastSyncedAtNode.textContent=prettyDate(this.mostRecentSyncTimestamp);}
else{this.lastSyncedAtNode.textContent=mozL10n.get('account-never-synced');}},updateSelfDom:function(isAccount){var str=isAccount?navigator.mozL10n.get('settings-account-section'):this.curAccount.name;this.domNode.getElementsByClassName('fld-folders-header-account-label')[0].textContent=str;if(this.curAccount.problems.length)
this.toolbarAccountProblemNode.classList.remove('collapsed');else
this.toolbarAccountProblemNode.classList.add('collapsed');},updateFolderDom:function(folder,firstTime){var folderNode=folder.element;if(firstTime){if(!folder.selectable)
folderNode.classList.add('fld-folder-unselectable');var depthIdx=Math.min(FOLDER_DEPTH_CLASSES.length-1,folder.depth);folderNode.classList.add(FOLDER_DEPTH_CLASSES[depthIdx]);folderNode.getElementsByClassName('fld-folder-name')[0].textContent=folder.name;}
if(folder===this.curFolder)
folderNode.classList.add('fld-folder-selected');else
folderNode.classList.remove('fld-folder-selected');},onClickFolder:function(folderNode,event){var folder=folderNode.folder;if(!folder.selectable)
return;var oldFolder=this.curFolder;this.curFolder=folder;this.updateFolderDom(oldFolder);this.updateFolderDom(folder);this._showFolder(folder);Cards.moveToCard(['message-list','nonsearch']);},_showFolder:function(folder){Cards.tellCard(['message-list','nonsearch'],{folder:folder});},die:function(){}};Cards.defineCard({name:'folder-picker',modes:{navigation:{tray:true},movetarget:{tray:false}},constructor:FolderPickerCard});function AccountPickerCard(domNode,mode,args){this.domNode=domNode;this.curAccount=args.curAccount;this.acctsSlice=args.acctsSlice;this.acctsSlice.onsplice=this.onAccountsSplice.bind(this);this.acctsSlice.onchange=this.onAccountsChange.bind(this);this.accountsContainer=domNode.getElementsByClassName('acct-list-container')[0];bindContainerHandler(this.accountsContainer,'click',this.onClickAccount.bind(this));domNode.getElementsByClassName('fld-accounts-btn')[0].addEventListener('click',this.onHideAccounts.bind(this),false);domNode.getElementsByClassName('fld-nav-settings-btn')[0].addEventListener('click',this.onShowSettings.bind(this),false);this.onAccountsSplice(0,0,this.acctsSlice.items,true,false);}
AccountPickerCard.prototype={die:function(){if(this.acctsSlice){this.acctsSlice.onsplice=null;this.acctsSlice.onchange=null;}},onShowSettings:function(){Cards.pushCard('settings-main','default','animate',{},'left');},onAccountsSplice:function(index,howMany,addedItems,requested,moreExpected){var accountsContainer=this.accountsContainer;var account;if(howMany){for(var i=index+howMany-1;i>=index;i--){account=this.acctsSlice.items[i];accountsContainer.removeChild(account.element);}}
var insertBuddy=(index>=accountsContainer.childElementCount)?null:accountsContainer.children[index],self=this;addedItems.forEach(function(account){var accountNode=account.element=fldNodes['account-item'].cloneNode(true);accountNode.account=account;self.updateAccountDom(account,true);accountsContainer.insertBefore(accountNode,insertBuddy);});},onHideAccounts:function(){Cards.removeCardAndSuccessors(this.domNode,'animate',1,['folder-picker','navigation']);},onAccountsChange:function(account){this.updateAccountDom(account,false);},updateAccountDom:function(account,firstTime){var accountNode=account.element;if(firstTime){accountNode.getElementsByClassName('fld-account-name')[0].textContent=account.name;}
if(account===this.curAccount){accountNode.classList.add('fld-account-selected');}
else{accountNode.classList.remove('fld-account-selected');}},onClickAccount:function(accountNode,event){var oldAccount=this.curAccount,account=this.curAccount=accountNode.account;if(oldAccount!==account){var folderCard=Cards.findCardObject(['folder-picker','navigation']);folderCard.cardImpl.updateAccount(account);}
this.onHideAccounts();}};Cards.defineCard({name:'account-picker',modes:{navigation:{tray:true},movetarget:{tray:false}},constructor:AccountPickerCard});;var requirejs,require,define;(function(global,undef){var prim,topReq,dataMain,bootstrapConfig=requirejs||require,hasOwn=Object.prototype.hasOwnProperty,contexts={},queue=[],currDirRegExp=/^\.\//,urlRegExp=/^\/|\:|\?|\.js$/,commentRegExp=/(\/\*([\s\S]*?)\*\/|([^:]|^)\/\/(.*)$)/mg,cjsRequireRegExp=/[^.]\s*require\s*\(\s*["']([^'"\s]+)["']\s*\)/g,jsSuffixRegExp=/\.js$/;if(typeof requirejs==='function'){return;}
function hasProp(obj,prop){return hasOwn.call(obj,prop);}
function getOwn(obj,prop){return obj&&hasProp(obj,prop)&&obj[prop];}
function eachProp(obj,func){var prop;for(prop in obj){if(hasProp(obj,prop)){if(func(obj[prop],prop)){break;}}}}
function mixin(target,source,force,deepStringMixin){if(source){eachProp(source,function(value,prop){if(force||!hasProp(target,prop)){if(deepStringMixin&&typeof value!=='string'){if(!target[prop]){target[prop]={};}
mixin(target[prop],value,force,deepStringMixin);}else{target[prop]=value;}}});}
return target;}
function getGlobal(value){if(!value){return value;}
var g=global;value.split('.').forEach(function(part){g=g[part];});return g;}
(function(){'use strict';var waitingId,waiting=[];function check(p){if(hasProp(p,'e')||hasProp(p,'v')){throw new Error('nope');}
return true;}
function callWaiting(){waitingId=0;var w=waiting;waiting=[];while(w.length){w.shift()();}}
function asyncTick(fn){waiting.push(fn);if(!waitingId){waitingId=setTimeout(callWaiting,0);}}
function notify(ary,value){prim.nextTick(function(){ary.forEach(function(item){item(value);});});}
prim=function prim(){var p,ok=[],fail=[];return(p={callback:function(yes,no){if(no){p.errback(no);}
if(hasProp(p,'v')){prim.nextTick(function(){yes(p.v);});}else{ok.push(yes);}},errback:function(no){if(hasProp(p,'e')){prim.nextTick(function(){no(p.e);});}else{fail.push(no);}},finished:function(){return hasProp(p,'e')||hasProp(p,'v');},rejected:function(){return hasProp(p,'e');},resolve:function(v){if(check(p)){p.v=v;notify(ok,v);}
return p;},reject:function(e){if(check(p)){p.e=e;notify(fail,e);}
return p;},start:function(fn){p.resolve();return p.promise.then(fn);},promise:{then:function(yes,no){var next=prim();p.callback(function(v){try{if(yes&&typeof yes==='function'){v=yes(v);}
if(v&&typeof v.then==='function'){v.then(next.resolve,next.reject);}else{next.resolve(v);}}catch(e){next.reject(e);}},function(e){var err;try{if(!no||typeof no!=='function'){next.reject(e);}else{err=no(e);if(err&&typeof err.then==='function'){err.then(next.resolve,next.reject);}else{next.resolve(err);}}}catch(e2){next.reject(e2);}});return next.promise;},fail:function(no){return p.promise.then(null,no);},end:function(){p.errback(function(e){throw e;});}}});};prim.serial=function(ary){var result=prim().resolve().promise;ary.forEach(function(item){result=result.then(function(){return item();});});return result;};prim.nextTick=typeof setImmediate==='function'?setImmediate:(typeof process!=='undefined'&&process.nextTick?process.nextTick:(typeof setTimeout!=='undefined'?asyncTick:function(fn){fn();}));}());function newContext(contextName){var req,main,makeMap,callDep,handlers,loadTimeId,load,context,defined={},waiting={},config={waitSeconds:7,baseUrl:'./',paths:{},pkgs:{},shim:{},config:{}},requireDeferreds=[],deferreds={},calledDefine={},calledPlugin={},loadCount=0,startTime=(new Date()).getTime(),errCount=0,trackedErrors={},urlFetched={};function trimDots(ary){var i,part;for(i=0;ary[i];i+=1){part=ary[i];if(part==='.'){ary.splice(i,1);i-=1;}else if(part==='..'){if(i===1&&(ary[2]==='..'||ary[0]==='..')){break;}else if(i>0){ary.splice(i-1,2);i-=2;}}}}
function normalize(name,baseName,applyMap){var pkgName,pkgConfig,mapValue,nameParts,i,j,nameSegment,foundMap,foundI,foundStarMap,starI,baseParts=baseName&&baseName.split('/'),normalizedBaseParts=baseParts,map=applyMap&&config.map,starMap=map&&map['*'];if(name&&name.charAt(0)==='.'){if(baseName){if(getOwn(config.pkgs,baseName)){normalizedBaseParts=baseParts=[baseName];}else{normalizedBaseParts=baseParts.slice(0,baseParts.length-1);}
name=normalizedBaseParts.concat(name.split('/'));trimDots(name);pkgConfig=getOwn(config.pkgs,(pkgName=name[0]));name=name.join('/');if(pkgConfig&&name===pkgName+'/'+pkgConfig.main){name=pkgName;}}else if(name.indexOf('./')===0){name=name.substring(2);}}
if(applyMap&&(baseParts||starMap)&&map){nameParts=name.split('/');for(i=nameParts.length;i>0;i-=1){nameSegment=nameParts.slice(0,i).join('/');if(baseParts){for(j=baseParts.length;j>0;j-=1){mapValue=getOwn(map,baseParts.slice(0,j).join('/'));if(mapValue){mapValue=getOwn(mapValue,nameSegment);if(mapValue){foundMap=mapValue;foundI=i;break;}}}}
if(foundMap){break;}
if(!foundStarMap&&starMap&&getOwn(starMap,nameSegment)){foundStarMap=getOwn(starMap,nameSegment);starI=i;}}
if(!foundMap&&foundStarMap){foundMap=foundStarMap;foundI=starI;}
if(foundMap){nameParts.splice(0,foundI,foundMap);name=nameParts.join('/');}}
return name;}
function makeShimExports(value){function fn(){var ret;if(value.init){ret=value.init.apply(global,arguments);}
return ret||(value.exports&&getGlobal(value.exports));}
return fn;}
function takeQueue(anonId){var i,id,args,shim;for(i=0;i<queue.length;i+=1){if(typeof queue[i][0]!=='string'){if(anonId){queue[i].unshift(anonId);anonId=undef;}else{break;}}
args=queue.shift();id=args[0];i-=1;if(!hasProp(defined,id)&&!hasProp(waiting,id)){if(hasProp(deferreds,id)){main.apply(undef,args);}else{waiting[id]=args;}}}
if(anonId){shim=getOwn(config.shim,anonId)||{};main(anonId,shim.deps||[],shim.exportsFn);}}
function makeRequire(relName,topLevel){var req=function(deps,callback,errback,alt){var name,cfg;if(topLevel){takeQueue();}
if(typeof deps==="string"){if(handlers[deps]){return handlers[deps](relName);}
name=makeMap(deps,relName,true).id;if(!hasProp(defined,name)){throw new Error('Not loaded: '+name);}
return defined[name];}else if(deps&&!Array.isArray(deps)){cfg=deps;deps=undef;if(Array.isArray(callback)){deps=callback;callback=errback;errback=alt;}
if(topLevel){return req.config(cfg)(deps,callback,errback);}}
callback=callback||function(){};prim.nextTick(function(){takeQueue();main(undef,deps||[],callback,errback,relName);});return req;};req.isBrowser=typeof document!=='undefined'&&typeof navigator!=='undefined';req.nameToUrl=function(moduleName,ext){var paths,pkgs,pkg,pkgPath,syms,i,parentModule,url,parentPath;if(urlRegExp.test(moduleName)){url=moduleName+(ext||'');}else{paths=config.paths;pkgs=config.pkgs;syms=moduleName.split('/');for(i=syms.length;i>0;i-=1){parentModule=syms.slice(0,i).join('/');pkg=getOwn(pkgs,parentModule);parentPath=getOwn(paths,parentModule);if(parentPath){if(Array.isArray(parentPath)){parentPath=parentPath[0];}
syms.splice(0,i,parentPath);break;}else if(pkg){if(moduleName===pkg.name){pkgPath=pkg.location+'/'+pkg.main;}else{pkgPath=pkg.location;}
syms.splice(0,i,pkgPath);break;}}
url=syms.join('/');url+=(ext||(/\?/.test(url)?'':'.js'));url=(url.charAt(0)==='/'||url.match(/^[\w\+\.\-]+:/)?'':config.baseUrl)+url;}
return config.urlArgs?url+
((url.indexOf('?')===-1?'?':'&')+
config.urlArgs):url;};req.toUrl=function(moduleNamePlusExt){var index=moduleNamePlusExt.lastIndexOf('.'),ext=null;if(index!==-1){ext=moduleNamePlusExt.substring(index,moduleNamePlusExt.length);moduleNamePlusExt=moduleNamePlusExt.substring(0,index);}
return req.nameToUrl(normalize(moduleNamePlusExt,relName),ext);};req.defined=function(id){return hasProp(defined,makeMap(id,relName,true).id);};req.specified=function(id){id=makeMap(id,relName,true).id;return hasProp(defined,id)||hasProp(deferreds,id);};return req;}
function resolve(name,d,value){if(name){defined[name]=value;}
d.resolve(value);}
function makeNormalize(relName){return function(name){return normalize(name,relName,true);};}
function defineModule(d){var name=d.map.id,ret=d.factory.apply(defined[name],d.values);if(name){if(d.cjsModule&&d.cjsModule.exports!==undef&&d.cjsModule.exports!==defined[name]){ret=d.cjsModule.exports;}else if(ret===undef&&d.usingExports){ret=defined[name];}
resolve(name,d,ret);}else{d.resolve();}}
function depFinished(val,i){if(!this.rejected()&&!this.depDefined[i]){this.depDefined[i]=true;this.depCount+=1;this.values[i]=val;if(this.depCount===this.depMax){defineModule(this);}}}
function makeDefer(name){var d=prim();d.map=name?makeMap(name,null,true):{};d.depCount=0;d.depMax=0;d.values=[];d.depDefined=[];d.depFinished=depFinished;if(d.map.pr){d.deps=[makeMap(d.map.pr)];}
return d;}
function getDefer(name){var d;if(name){d=hasProp(deferreds,name)&&deferreds[name];if(!d){d=deferreds[name]=makeDefer(name);}}else{d=makeDefer();requireDeferreds.push(d);}
return d;}
function makeErrback(d,name){return function(err){if(!d.rejected()){if(!err.dynaId){err.dynaId='id'+(errCount+=1);err.requireModules=[name];}
d.reject(err);}};}
function waitForDep(depMap,relName,d,i){d.depMax+=1;callDep(depMap,relName).then(function(val){d.depFinished(val,i);},makeErrback(d,depMap.id)).fail(makeErrback(d,d.map.id));}
function makeLoad(id){var fromTextCalled;function load(value){if(!fromTextCalled){resolve(id,getDefer(id),value);}}
load.error=function(err){getDefer(id).reject(err);};load.fromText=function(text,textAlt){var d=getDefer(id),map=makeMap(makeMap(id).n),plainId=map.id;fromTextCalled=true;d.factory=function(p,val){return val;};if(textAlt){text=textAlt;}
if(hasProp(config.config,id)){config.config[plainId]=config.config[id];}
try{req.exec(text);}catch(e){throw new Error('fromText eval for '+plainId+' failed: '+e);}
takeQueue(plainId);d.deps=[map];waitForDep(map,null,d,d.deps.length);};return load;}
load=typeof importScripts==='function'?function(map){var url=map.url;if(urlFetched[url]){return;}
urlFetched[url]=true;getDefer(map.id);importScripts(url);takeQueue(map.id);}:function(map){var script,id=map.id,url=map.url;if(urlFetched[url]){return;}
urlFetched[url]=true;script=document.createElement('script');script.setAttribute('data-requiremodule',id);script.type=config.scriptType||'text/javascript';script.charset='utf-8';script.async=true;loadCount+=1;script.addEventListener('load',function(){loadCount-=1;takeQueue(id);},false);script.addEventListener('error',function(){loadCount-=1;var err,pathConfig=getOwn(config.paths,id),d=getOwn(deferreds,id);if(pathConfig&&Array.isArray(pathConfig)&&pathConfig.length>1){script.parentNode.removeChild(script);pathConfig.shift();d.map=makeMap(id);load(d.map);}else{err=new Error('Load failed: '+id+': '+script.url);err.requireModules=[id];getDefer(id).reject(err);}},false);script.src=url;document.head.appendChild(script);};function callPlugin(plugin,map,relName){plugin.load(map.n,makeRequire(relName),makeLoad(map.id),{});}
callDep=function(map,relName){var args,name=map.id,shim=config.shim[name];if(hasProp(waiting,name)){args=waiting[name];delete waiting[name];main.apply(undef,args);}else if(!hasProp(deferreds,name)){if(map.pr){return callDep(makeMap(map.pr)).then(function(plugin){var newMap=makeMap(name,relName,true),newId=newMap.id,shim=getOwn(config.shim,newId);if(!hasProp(calledPlugin,newId)){calledPlugin[newId]=true;if(shim&&shim.deps){req(shim.deps,function(){callPlugin(plugin,newMap,relName);});}else{callPlugin(plugin,newMap,relName);}}
return getDefer(newId).promise;});}else if(shim&&shim.deps){req(shim.deps,function(){load(map);});}else{load(map);}}
return getDefer(name).promise;};function splitPrefix(name){var prefix,index=name?name.indexOf('!'):-1;if(index>-1){prefix=name.substring(0,index);name=name.substring(index+1,name.length);}
return[prefix,name];}
makeMap=function(name,relName,applyMap){if(typeof name!=='string'){return name;}
var plugin,url,parts=splitPrefix(name),prefix=parts[0];name=parts[1];if(prefix){prefix=normalize(prefix,relName,applyMap);plugin=hasProp(defined,prefix)&&defined[prefix];}
if(prefix){if(plugin&&plugin.normalize){name=plugin.normalize(name,makeNormalize(relName));}else{name=normalize(name,relName,applyMap);}}else{name=normalize(name,relName,applyMap);parts=splitPrefix(name);prefix=parts[0];name=parts[1];url=req.nameToUrl(name);}
return{id:prefix?prefix+'!'+name:name,n:name,pr:prefix,url:url};};function makeConfig(name){return function(){return config.config[name]||{};};}
handlers={require:function(name){return makeRequire(name);},exports:function(name){var e=defined[name];if(typeof e!=='undefined'){return e;}else{return(defined[name]={});}},module:function(name){return{id:name,uri:'',exports:defined[name],config:makeConfig(name)};}};function breakCycle(d,traced,processed){var id=d.map.id;traced[id]=true;if(!d.finished()&&d.deps){d.deps.forEach(function(depMap){var depIndex,depId=depMap.id,dep=!hasProp(handlers,depId)&&getDefer(depId);if(dep&&!dep.finished()&&!processed[depId]){if(hasProp(traced,depId)){d.deps.some(function(depMap,i){if(depMap.id===depId){depIndex=i;return true;}});d.depFinished(defined[depId],depIndex);}else{breakCycle(dep,traced,processed);}}});}
processed[id]=true;}
function check(){loadTimeId=0;var err,reqDefs=[],noLoads=[],waitInterval=config.waitSeconds*1000,expired=waitInterval&&(startTime+waitInterval)<(new Date()).getTime();if(loadCount===0){reqDefs=requireDeferreds.filter(function(d){return!d.finished();});if(reqDefs.length){eachProp(deferreds,function(d){if(!d.finished()){noLoads.push(d);}});if(noLoads.length){reqDefs.forEach(function(d){breakCycle(d,{},{});});}}}
if(expired){noLoads=noLoads.map(function(d){return d.map.id;});err=new Error('Timeout for modules: '+noLoads);err.requireModules=noLoads;req.onError(err);}else if(loadCount||reqDefs.length){if(!loadTimeId){loadTimeId=prim.nextTick(check);}}}
function delayedError(e){prim.nextTick(function(){if(!e.dynaId||!trackedErrors[e.dynaId]){trackedErrors[e.dynaId]=true;req.onError(e);}});}
main=function(name,deps,factory,errback,relName){if(name&&hasProp(calledDefine,name)){return;}
calledDefine[name]=true;var d=getDefer(name);if(deps&&!Array.isArray(deps)){factory=deps;deps=[];}
d.promise.fail(errback||delayedError);relName=relName||name;if(typeof factory==='function'){if(!deps.length&&factory.length){factory.toString().replace(commentRegExp,'').replace(cjsRequireRegExp,function(match,dep){deps.push(dep);});deps=(factory.length===1?['require']:['require','exports','module']).concat(deps);}
d.factory=factory;d.deps=deps;deps.forEach(function(depName,i){var depMap;deps[i]=depMap=makeMap(depName,relName,true);depName=depMap.id;if(depName==="require"){d.values[i]=handlers.require(name);}else if(depName==="exports"){d.values[i]=handlers.exports(name);d.usingExports=true;}else if(depName==="module"){d.values[i]=d.cjsModule=handlers.module(name);}else{waitForDep(depMap,relName,d,i);}});if(d.depCount===d.depMax){defineModule(d);}}else if(name){resolve(name,d,factory);}
startTime=(new Date()).getTime();if(!name){check();}};req=makeRequire(null,true);req.config=function(cfg){if(cfg.context&&cfg.context!==contextName){return newContext(cfg.context).config(cfg);}
if(cfg.baseUrl){if(cfg.baseUrl.charAt(cfg.baseUrl.length-1)!=='/'){cfg.baseUrl+='/';}}
var primId,pkgs=config.pkgs,shim=config.shim,objs={paths:true,config:true,map:true};eachProp(cfg,function(value,prop){if(objs[prop]){if(prop==='map'){if(!config.map){config.map={};}
mixin(config[prop],value,true,true);}else{mixin(config[prop],value,true);}}else{config[prop]=value;}});if(cfg.shim){eachProp(cfg.shim,function(value,id){if(Array.isArray(value)){value={deps:value};}
if((value.exports||value.init)&&!value.exportsFn){value.exportsFn=makeShimExports(value);}
shim[id]=value;});config.shim=shim;}
if(cfg.packages){cfg.packages.forEach(function(pkgObj){var location;pkgObj=typeof pkgObj==='string'?{name:pkgObj}:pkgObj;location=pkgObj.location;pkgs[pkgObj.name]={name:pkgObj.name,location:location||pkgObj.name,main:(pkgObj.main||'main').replace(currDirRegExp,'').replace(jsSuffixRegExp,'')};});config.pkgs=pkgs;}
primId=config.definePrim;if(primId){waiting[primId]=[primId,[],function(){return prim;}];}
if(cfg.deps){req(cfg.deps,cfg.callback);}
return req;};req.onError=function(err){throw err;};context={id:contextName,defined:defined,waiting:waiting,config:config,deferreds:deferreds};contexts[contextName]=context;return req;}
requirejs=topReq=newContext('_');if(typeof require!=='function'){require=topReq;}
topReq.exec=function(text){return eval(text);};topReq.contexts=contexts;define=function(){queue.push([].slice.call(arguments,0));};define.amd={jQuery:true};if(bootstrapConfig){topReq.config(bootstrapConfig);}
if(topReq.isBrowser){dataMain=document.querySelectorAll('script[data-main]')[0];dataMain=dataMain&&dataMain.getAttribute('data-main');if(dataMain){dataMain=dataMain.replace(jsSuffixRegExp,'');topReq([dataMain]);}}}(this));;require.config({baseUrl:'..',paths:{mailcomposer:'mailapi/composer','wbxml':'mailapi/activesync/protocollayer','activesync/codepages':'mailapi/activesync/protocollayer','activesync/protocol':'mailapi/activesync/protocollayer','activesync/codepages/FolderHierarchy':'mailapi/activesync/configurator','activesync/codepages/ComposeMail':'mailapi/activesync/configurator','activesync/codepages/AirSync':'mailapi/activesync/configurator','activesync/codepages/AirSyncBase':'mailapi/activesync/configurator','activesync/codepages/ItemEstimate':'mailapi/activesync/configurator','activesync/codepages/Email':'mailapi/activesync/configurator','activesync/codepages/ItemOperations':'mailapi/activesync/configurator','activesync/codepages/Move':'mailapi/activesync/configurator','mailapi/htmlchew':'mailapi/chewlayer','mailapi/quotechew':'mailapi/chewlayer','mailapi/mailchew':'mailapi/chewlayer','mailapi/imap/imapchew':'mailapi/chewlayer','mailapi/imap/protocol/sync':'mailapi/imap/protocollayer','mailapi/imap/protocol/textparser':'mailapi/imap/protocollayer','mailapi/imap/protocol/snippetparser':'mailapi/imap/protocollayer','mailapi/imap/protocol/bodyfetcher':'mailapi/imap/protocollayer','imap':'mailapi/imap/probe','simplesmtp/lib/client':'mailapi/smtp/probe'},scriptType:'application/javascript;version=1.8',definePrim:'prim'});define('q',['prim'],function(prim){return{defer:prim};});require.config({baseUrl:'js/ext'});(function(){var evtObject=document.createEvent('Event');evtObject.initEvent('mailapi',false,false);window.tempMailAPI=evtObject.mailAPI={_fake:true,hasAccounts:(document.cookie||'').indexOf('mailHasAccounts')!==-1,useLocalizedStrings:function(){},viewAccounts:function(){var acctSlice={items:[],die:function(){}};setTimeout(function(){if(acctSlice.oncomplete){acctSlice.oncomplete();}
require(['mailapi/main-frame-setup']);},0);return acctSlice;}};window.dispatchEvent(evtObject);}());;'use strict';var LazyLoader=(function(){function LazyLoader(){this._loaded={};this._isLoading={};}
LazyLoader.prototype={_js:function(file,callback){var script=document.createElement('script');script.src=file;script.addEventListener('load',callback);document.head.appendChild(script);this._isLoading[file]=script;},_css:function(file,callback){var style=document.createElement('link');style.type='text/css';style.rel='stylesheet';style.href=file;document.head.appendChild(style);callback();},_html:function(domNode,callback){for(var i=0;i<domNode.childNodes.length;i++){if(domNode.childNodes[i].nodeType==document.COMMENT_NODE){domNode.innerHTML=domNode.childNodes[i].nodeValue;break;}}
callback();},load:function(files,callback){if(!Array.isArray(files))
files=[files];var loadsRemaining=files.length,self=this;function perFileCallback(file){if(self._isLoading[file])
delete self._isLoading[file];self._loaded[file]=true;if(--loadsRemaining===0){if(callback)
callback();}}
for(var i=0;i<files.length;i++){var file=files[i];if(this._loaded[file]){perFileCallback(file);}else if(this._isLoading[file]){this._isLoading[file].addEventListener('load',perFileCallback.bind(null,file));}else{var method,idx;if(typeof file==='string'){method=file.match(/\.(.*?)$/)[1];idx=file;}else{method='html';idx=file.id;}
this['_'+method](file,perFileCallback.bind(null,idx));}}}};return new LazyLoader();}());;var MailAPI=null;var App={initialized:false,loader:LazyLoader,preloadAll:function(cb){cb=cb||function(){};App.loader.load(['style/value_selector.css','style/compose-cards.css','style/setup-cards.css','js/value_selector.js','js/iframe-shims.js','js/setup-cards.js','js/compose-cards.js'],cb);},_init:function(){if(!MailAPI._fake){MailAPI.onbadlogin=function(account,problem){switch(problem){case'bad-user-or-pass':Cards.pushCard('setup-fix-password','default','animate',{account:account,restoreCard:Cards.activeCardIndex},'right');break;case'imap-disabled':Cards.pushCard('setup-fix-gmail-imap','default','animate',{account:account,restoreCard:Cards.activeCardIndex},'right');break;case'needs-app-pass':Cards.pushCard('setup-fix-gmail-twofactor','default','animate',{account:account,restoreCard:Cards.activeCardIndex},'right');break;}};MailAPI.useLocalizedStrings({wrote:mozL10n.get('reply-quoting-wrote'),originalMessage:mozL10n.get('forward-original-message'),forwardHeaderLabels:{subject:mozL10n.get('forward-header-subject'),date:mozL10n.get('forward-header-date'),from:mozL10n.get('forward-header-from'),replyTo:mozL10n.get('forward-header-reply-to'),to:mozL10n.get('forward-header-to'),cc:mozL10n.get('forward-header-cc')},folderNames:{inbox:mozL10n.get('folder-inbox'),sent:mozL10n.get('folder-sent'),drafts:mozL10n.get('folder-drafts'),trash:mozL10n.get('folder-trash'),queue:mozL10n.get('folder-queue'),junk:mozL10n.get('folder-junk'),archives:mozL10n.get('folder-archives')}});}
this.initialized=true;},showMessageViewOrSetup:function(showLatest){var acctsSlice=MailAPI.viewAccounts(false);acctsSlice.oncomplete=function(){if(acctsSlice.items.length&&!MailAPI._fake){var account=showLatest?acctsSlice.items.slice(-1)[0]:acctsSlice.items[0];var foldersSlice=MailAPI.viewFolders('account',account);foldersSlice.oncomplete=function(){var inboxFolder=foldersSlice.getFirstFolderWithType('inbox');if(!inboxFolder)
dieOnFatalError('We have an account without an inbox!',foldersSlice.items);var hasMessageListCard=Cards.hasCard(['message-list','nonsearch']);if(hasMessageListCard){Cards.tellCard(['message-list','nonsearch'],{folder:inboxFolder});}else{Cards.removeAllCards();Cards.pushCard('message-list','nonsearch','immediate',{folder:inboxFolder});}
Cards.pushCard('folder-picker','navigation','none',{acctsSlice:acctsSlice,curAccount:account,foldersSlice:foldersSlice,curFolder:inboxFolder},'left');if(activityCallback){activityCallback();activityCallback=null;}};}else if(MailAPI._fake&&MailAPI.hasAccounts){Cards.assertNoCards();Cards.pushCard('message-list','nonsearch','immediate',{folder:null});}
else if(!Cards.hasCard(['setup-account-info','default'])){acctsSlice.die();if(activityCallback){var activityCb=activityCallback;activityCallback=null;var result=activityCb();if(!result)
return;}
Cards.removeAllCards();Cards.pushCard('setup-account-info','default','immediate',{allowBack:false});}
if(MailAPI._fake){setTimeout(function preloadTimeout(){App.preloadAll();},4000);}};}};var queryURI=function _queryURI(uri){function addressesToArray(addresses){if(!addresses)
return[''];addresses=addresses.split(';');var addressesArray=addresses.filter(function notEmpty(addr){return addr.trim()!='';});return addressesArray;}
var mailtoReg=/^mailto:(.*)/i;if(uri.match(mailtoReg)){uri=uri.match(mailtoReg)[1];var parts=uri.split('?');var subjectReg=/(?:^|&)subject=([^\&]*)/i,bodyReg=/(?:^|&)body=([^\&]*)/i,ccReg=/(?:^|&)cc=([^\&]*)/i,bccReg=/(?:^|&)bcc=([^\&]*)/i;var to=addressesToArray(decodeURIComponent(parts[0])),subject,body,cc,bcc;if(parts.length==2){var data=parts[1];if(data.match(subjectReg))
subject=decodeURIComponent(data.match(subjectReg)[1]);if(data.match(bodyReg))
body=decodeURIComponent(data.match(bodyReg)[1]);if(data.match(ccReg))
cc=addressesToArray(decodeURIComponent(data.match(ccReg)[1]));if(parts[1].match(bccReg))
bcc=addressesToArray(decodeURIComponent(data.match(bccReg)[1]));}
return[to,subject,body,cc,bcc];}};function hookStartup(){var gotLocalized=(mozL10n.readyState==='interactive')||(mozL10n.readystate==='complete'),gotMailAPI=false,inited=false;function doInit(){try{if(inited){if(!MailAPI._fake){App._init();App.showMessageViewOrSetup();}}else{inited=true;populateTemplateNodes();Cards._init();App._init();App.showMessageViewOrSetup();}}
catch(ex){console.error('Problem initializing',ex,'\n',ex.stack);}}
if(!gotLocalized){window.addEventListener('localized',function localized(){console.log('got localized!');gotLocalized=true;window.removeEventListener('localized',localized);if(gotMailAPI)
doInit();});}
window.addEventListener('mailapi',function(event){console.log('got MailAPI!');MailAPI=event.mailAPI;gotMailAPI=true;if(gotLocalized)
doInit();},false);if(window.tempMailAPI){console.log('got MailAPI from window!');MailAPI=window.tempMailAPI;gotMailAPI=true;if(gotLocalized)
doInit();}}
hookStartup();var activityCallback=null;if('mozSetMessageHandler'in window.navigator){window.navigator.mozSetMessageHandler('activity',function actHandle(activity){var activityName=activity.source.name;console.log('activity!',activityName);if(activityName==='share'){var attachmentBlobs=activity.source.data.blobs,attachmentNames=activity.source.data.filenames;}
else if(activityName==='new'||activityName==='view'){var parts=queryURI(activity.source.data.url||activity.source.data.URI);var to=parts[0];var subject=parts[1];var body=parts[2];var cc=parts[3];var bcc=parts[4];}
var sendMail=function actHandleMail(){var folderToUse;try{folderToUse=Cards._cardStack[Cards._findCard(['folder-picker','navigation'])].cardImpl.curFolder;}catch(e){console.log('no navigation found:',e);var req=confirm(mozL10n.get('setup-empty-account-prompt'));if(!req){activity.postError('cancelled');window.close();return false;}
activityCallback=sendMail;return true;}
var composer=MailAPI.beginMessageComposition(null,folderToUse,null,function(){if(to)
composer.to=to;if(subject)
composer.subject=subject;if(body&&typeof body==='string')
composer.body={text:body};if(cc)
composer.cc=cc;if(bcc)
composer.bcc=bcc;if(attachmentBlobs){for(var iBlob=0;iBlob<attachmentBlobs.length;iBlob++){composer.addAttachment({name:attachmentNames[iBlob],blob:attachmentBlobs[iBlob]});}}
Cards.pushCard('compose','default','immediate',{composer:composer,activity:activity});activityLock=false;});};if(MailAPI&&!MailAPI._fake){console.log('activity',activityName,'triggering compose now');sendMail();}else{console.log('activity',activityName,'waiting for callback');activityCallback=sendMail;}});}
else{console.warn('Activity support disabled!');}