;'use strict';(function(window){var gL10nData={};var gTextProp='textContent';var gLanguage='';var gMacros={};var gReadyState='loading';var gAsyncResourceLoading=true;var gDEBUG=1;function consoleLog(message){if(gDEBUG>=2){console.log('[l10n] '+message);}};function consoleWarn(message){if(gDEBUG){console.warn('[l10n] '+message);}};function getL10nResourceLinks(){return document.querySelectorAll('link[type="application/l10n"]');}
function getL10nDictionary(){var script=document.querySelector('script[type="application/l10n"]');return script?JSON.parse(script.innerHTML):null;}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function getL10nAttributes(element){if(!element)
return{};var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args={};if(l10nArgs){try{args=JSON.parse(l10nArgs);}catch(e){consoleWarn('could not parse arguments for #'+l10nId);}}
return{id:l10nId,args:args};}
function fireL10nReadyEvent(){var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=gLanguage;window.dispatchEvent(evtObject);}
function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/\/[^\/]*$/,'/');function evalString(text){if(text.lastIndexOf('\\')<0)
return text;return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text){var dictionary=[];var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax){var entries=rawText.replace(reBlank,'').split(/[\r\n]+/);var currentLang='*';var genericLang=lang.replace(/-[a-z]+$/i,'');var skipLang=false;var match='';for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(extendedSyntax){if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=='*')&&(currentLang!==lang)&&(currentLang!==genericLang);continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);loadImport(baseURL+match[1]);}}
var tmp=line.match(reSplit);if(tmp&&tmp.length==3){dictionary[tmp[1]]=evalString(tmp[2]);}}}
function loadImport(url){loadResource(url,function(content){parseRawLines(content,false);},null,false);}
parseRawLines(text,true);return dictionary;}
function loadResource(url,onSuccess,onFailure,asynchronous){onSuccess=onSuccess||function _onSuccess(data){};onFailure=onFailure||function _onFailure(){consoleWarn(url+' not found.');};var xhr=new XMLHttpRequest();xhr.open('GET',url,asynchronous);if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain; charset=utf-8');}
xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status===0){onSuccess(xhr.responseText);}else{onFailure();}}};xhr.onerror=onFailure;xhr.ontimeout=onFailure;try{xhr.send(null);}catch(e){onFailure();}}
loadResource(href,function(response){var data=parseProperties(response);for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop=gTextProp;}
if(!gL10nData[id]){gL10nData[id]={};}
gL10nData[id][prop]=data[key];}
if(successCallback){successCallback();}},failureCallback,gAsyncResourceLoading);};function loadLocale(lang,callback){callback=callback||function _callback(){};clear();gLanguage=lang;var langLinks=getL10nResourceLinks();var langCount=langLinks.length;if(langCount==0){var dict=getL10nDictionary();if(dict&&dict.locales&&dict.default_locale){consoleLog('using the embedded JSON directory, early way out');gL10nData=dict.locales[lang]||dict.locales[dict.default_locale];callback();}else{consoleLog('no resource to load, early way out');}
fireL10nReadyEvent(lang);gReadyState='complete';return;}
var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){callback();fireL10nReadyEvent(lang);gReadyState='complete';}};function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;parseResource(href,lang,callback,function(){consoleWarn(href+' not found.');applied='';});return applied;};}
for(var i=0;i<langCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang){consoleWarn('"'+lang+'" resource not found');gLanguage='';}}}
function clear(){gL10nData={};gLanguage='';}
function getPluralRules(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return start<=n&&n<=end;}
var pluralRules={'0':function(n){return'other';},'1':function(n){if((isBetween((n%100),3,10)))
return'few';if(n===0)
return'zero';if((isBetween((n%100),11,99)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'2':function(n){if(n!==0&&(n%10)===0)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'3':function(n){if(n==1)
return'one';return'other';},'4':function(n){if((isBetween(n,0,1)))
return'one';return'other';},'5':function(n){if((isBetween(n,0,2))&&n!=2)
return'one';return'other';},'6':function(n){if(n===0)
return'zero';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'7':function(n){if(n==2)
return'two';if(n==1)
return'one';return'other';},'8':function(n){if((isBetween(n,3,6)))
return'few';if((isBetween(n,7,10)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'9':function(n){if(n===0||n!=1&&(isBetween((n%100),1,19)))
return'few';if(n==1)
return'one';return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19)))
return'few';if((n%10)==1&&!(isBetween((n%100),11,19)))
return'one';return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14)))
return'many';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'12':function(n){if((isBetween(n,2,4)))
return'few';if(n==1)
return'one';return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if(n!=1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14)))
return'many';if(n==1)
return'one';return'other';},'14':function(n){if((isBetween((n%100),3,4)))
return'few';if((n%100)==2)
return'two';if((n%100)==1)
return'one';return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10)))
return'few';if((isBetween((n%100),11,19)))
return'many';if(n==1)
return'one';return'other';},'16':function(n){if((n%10)==1&&n!=11)
return'one';return'other';},'17':function(n){if(n==3)
return'few';if(n===0)
return'zero';if(n==6)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'18':function(n){if(n===0)
return'zero';if((isBetween(n,0,2))&&n!==0&&n!=2)
return'one';return'other';},'19':function(n){if((isBetween(n,2,10)))
return'few';if((isBetween(n,0,1)))
return'one';return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)==9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99)))
return'few';if((n%1000000)===0&&n!==0)
return'many';if((n%10)==2&&!isIn((n%100),[12,72,92]))
return'two';if((n%10)==1&&!isIn((n%100),[11,71,91]))
return'one';return'other';},'21':function(n){if(n===0)
return'zero';if(n==1)
return'one';return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99)))
return'one';return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0)
return'one';return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19)))
return'few';if(isIn(n,[2,12]))
return'two';if(isIn(n,[1,11]))
return'one';return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){consoleWarn('plural form unknown for ['+lang+']');return function(){return'other';};}
return pluralRules[index];}
gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))
return str;if(prop!=gTextProp)
return str;if(!gMacros._pluralRules){gMacros._pluralRules=getPluralRules(gLanguage);}
var index='['+gMacros._pluralRules(n)+']';if(n===0&&(key+'[zero]')in gL10nData){str=gL10nData[key+'[zero]'][prop];}else if(n==1&&(key+'[one]')in gL10nData){str=gL10nData[key+'[one]'][prop];}else if(n==2&&(key+'[two]')in gL10nData){str=gL10nData[key+'[two]'][prop];}else if((key+index)in gL10nData){str=gL10nData[key+index][prop];}else if((key+'[other]')in gL10nData){str=gL10nData[key+'[other]'][prop];}
return str;};function getL10nData(key,args){var data=gL10nData[key];if(!data){consoleWarn('#'+key+' is undefined.');}
var rv={};for(var prop in data){var str=data[prop];str=substIndexes(str,args,key,prop);str=substArguments(str,args,key);rv[prop]=str;}
return rv;}
function substIndexes(str,args,key,prop){var reIndex=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;var reMatch=reIndex.exec(str);if(!reMatch||!reMatch.length)
return str;var macroName=reMatch[1];var paramName=reMatch[2];var param;if(args&&paramName in args){param=args[paramName];}else if(paramName in gL10nData){param=gL10nData[paramName];}
if(macroName in gMacros){var macro=gMacros[macroName];str=macro(str,param,key,prop);}
return str;}
function substArguments(str,args,key){var reArgs=/\{\{\s*(.+?)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(args&&arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg][gTextProp];}else{consoleLog('argument {{'+arg+'}} for #'+key+' is undefined.');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var data=getL10nData(l10n.id,l10n.args);if(!data){consoleWarn('#'+l10n.id+' is undefined.');return;}
if(data[gTextProp]){if(element.children.length===0){element[gTextProp]=data[gTextProp];}else{var children=element.childNodes;var found=false;for(var i=0,l=children.length;i<l;i++){if(children[i].nodeType===3&&/\S/.test(children[i].nodeValue)){if(found){children[i].nodeValue='';}else{children[i].nodeValue=data[gTextProp];found=true;}}}
if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild);}}
delete data[gTextProp];}
for(var k in data){element[k]=data[k];}}
function translateFragment(element){element=element||document.documentElement;var children=getTranslatableChildren(element);var elementCount=children.length;for(var i=0;i<elementCount;i++){translateElement(children[i]);}
translateElement(element);}
function l10nStartup(){gReadyState='interactive';consoleLog('loading ['+navigator.language+'] resources, '+
(gAsyncResourceLoading?'asynchronously.':'synchronously.'));if(document.documentElement.lang===navigator.language){loadLocale(navigator.language);}else{loadLocale(navigator.language,translateFragment);}}
if(typeof(document)!=='undefined'){if(document.readyState==='complete'||document.readyState==='interactive'){window.setTimeout(l10nStartup);}else{document.addEventListener('DOMContentLoaded',l10nStartup);}}
if('mozSettings'in navigator&&navigator.mozSettings){navigator.mozSettings.addObserver('language.current',function(event){loadLocale(event.settingValue,translateFragment);});}
navigator.mozL10n={get:function l10n_get(key,args,fallback){var data=getL10nData(key,args)||fallback;if(data){return'textContent'in data?data.textContent:'';}
return'{{'+key+'}}';},get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};},translate:translateFragment,get dictionary(){return JSON.parse(JSON.stringify(gL10nData));},get readyState(){return gReadyState;},ready:function l10n_ready(callback){if(!callback){return;}else if(gReadyState=='complete'||gReadyState=='interactive'){window.setTimeout(callback);}else{window.addEventListener('localized',callback);}}};consoleLog('library loaded.');})(this);;'use strict';this.asyncStorage=(function(){var DBNAME='asyncStorage';var DBVERSION=1;var STORENAME='keyvaluepairs';var db=null;function withStore(type,f){if(db){f(db.transaction(STORENAME,type).objectStore(STORENAME));}else{var openreq=indexedDB.open(DBNAME,DBVERSION);openreq.onerror=function withStoreOnError(){console.error("asyncStorage: can't open database:",openreq.error.name);};openreq.onupgradeneeded=function withStoreOnUpgradeNeeded(){openreq.result.createObjectStore(STORENAME);};openreq.onsuccess=function withStoreOnSuccess(){db=openreq.result;f(db.transaction(STORENAME,type).objectStore(STORENAME));};}}
function getItem(key,callback){withStore('readonly',function getItemBody(store){var req=store.get(key);req.onsuccess=function getItemOnSuccess(){var value=req.result;if(value===undefined)
value=null;callback(value);};req.onerror=function getItemOnError(){console.error('Error in asyncStorage.getItem(): ',req.error.name);};});}
function setItem(key,value,callback){withStore('readwrite',function setItemBody(store){var req=store.put(value,key);if(callback){req.onsuccess=function setItemOnSuccess(){callback();};}
req.onerror=function setItemOnError(){console.error('Error in asyncStorage.setItem(): ',req.error.name);};});}
function removeItem(key,callback){withStore('readwrite',function removeItemBody(store){var req=store.delete(key);if(callback){req.onsuccess=function removeItemOnSuccess(){callback();};}
req.onerror=function removeItemOnError(){console.error('Error in asyncStorage.removeItem(): ',req.error.name);};});}
function clear(callback){withStore('readwrite',function clearBody(store){var req=store.clear();if(callback){req.onsuccess=function clearOnSuccess(){callback();};}
req.onerror=function clearOnError(){console.error('Error in asyncStorage.clear(): ',req.error.name);};});}
function length(callback){withStore('readonly',function lengthBody(store){var req=store.count();req.onsuccess=function lengthOnSuccess(){callback(req.result);};req.onerror=function lengthOnError(){console.error('Error in asyncStorage.length(): ',req.error.name);};});}
function key(n,callback){if(n<0){callback(null);return;}
withStore('readonly',function keyBody(store){var advanced=false;var req=store.openCursor();req.onsuccess=function keyOnSuccess(){var cursor=req.result;if(!cursor){callback(null);return;}
if(n===0){callback(cursor.key);}else{if(!advanced){advanced=true;cursor.advance(n);}else{callback(cursor.key);}}};req.onerror=function keyOnError(){console.error('Error in asyncStorage.key(): ',req.error.name);};});}
return{getItem:getItem,setItem:setItem,removeItem:removeItem,clear:clear,length:length,key:key};}());;'use strict';var NotificationHelper={_referencesArray:[],getIconURI:function nc_getIconURI(app,entryPoint){var icons=app.manifest.icons;if(entryPoint){icons=app.manifest.entry_points[entryPoint].icons;}
if(!icons)
return null;var sizes=Object.keys(icons).map(function parse(str){return parseInt(str,10);});sizes.sort(function(x,y){return y-x;});var HVGA=document.documentElement.clientWidth<480;var index=sizes[HVGA?sizes.length-1:0];return app.installOrigin+icons[index];},send:function nc_send(title,body,icon,clickCB,closeCB){if(!('mozNotification'in navigator))
return;var notification=navigator.mozNotification.createNotification(title,body,icon);notification.onclick=(function(){if(clickCB)
clickCB();this._forget(notification);}).bind(this);notification.onclose=(function(){if(closeCB)
closeCB();this._forget(notification);}).bind(this);notification.show();this._keep(notification);},_keep:function nc_keep(notification){this._referencesArray.push(notification);},_forget:function nc_forget(notification){this._referencesArray.splice(this._referencesArray.indexOf(notification),1);}};;'use strict';var SettingsListener={_timer:null,_lock:null,getSettingsLock:function sl_getSettingsLock(){clearTimeout(this._timer);this._timer=setTimeout((function removeLock(){this._lock=null;}).bind(this),0);if(this._lock){return this._lock;}
var settings=window.navigator.mozSettings;return(this._lock=settings.createLock());},observe:function sl_observe(name,defaultValue,callback){var settings=window.navigator.mozSettings;if(!settings){window.setTimeout(function(){callback(defaultValue);});return;}
var req;try{req=this.getSettingsLock().get(name);}catch(e){console.warn('Stale lock in settings_listener.js.','See https://bugzilla.mozilla.org/show_bug.cgi?id=793239');this._lock=null;req=this.getSettingsLock().get(name);}
req.addEventListener('success',(function onsuccess(){callback(typeof(req.result[name])!='undefined'?req.result[name]:defaultValue);}));settings.addObserver(name,function settingChanged(evt){callback(evt.settingValue);});}};;var DEBUGGING=false;var debug=(function(){var SEQ_ID=0;var PROCESS_ID=Date.now();var DEBUG_PREFIX='CC';return function _debug(){if(!DEBUGGING){return;}
var currentWindow=window;var parents=[];while(currentWindow!==currentWindow.parent){parents.push(currentWindow.location.pathname);currentWindow=currentWindow.parent;}
parents.push(currentWindow.location.pathname);parents=parents.reverse().join('>')+':';var uId=PROCESS_ID;var message=['('+uId+'-'+(SEQ_ID++)+')',DEBUG_PREFIX,parents];for(var i=0,len=arguments.length,obj;i<len;i++){obj=arguments[i];message.push(typeof obj==='object'?JSON.stringify(obj):obj);}
if(window.dump){window.dump(message.join(' '));}else if(console&&console.log){console.log(message.join(' '));}};}());;'use strict';var _=function cc_fallbackTranslation(keystring){var r=navigator.mozL10n.get.apply(this,arguments);return r||(DEBUGGING?'!!':'')+keystring;};function toMidnight(date){date.setHours(0);date.setMinutes(0);date.setSeconds(0);date.setMilliseconds(0);return date;}
function deepCopy(object){if(object===null||!(object instanceof Object)){return object;}
var clone,constructor=object.constructor;switch(constructor){case Date:clone=new constructor(object.getTime());break;default:clone=constructor();break;}
for(var key in object){if(object.hasOwnProperty(key)){clone[key]=deepCopy(object[key]);}}
return clone;}
Object.prototype.extend=function _extend(){for(var i=0,len=arguments.length;i<len;i++){var object=arguments[i];for(var name in object){if(object.hasOwnProperty(name)){this[name]=object[name];}}}
return this;};var NOP=function(){};function checkEnoughDelay(threshold,dateA,dateB){if(!dateA){return true;}
var end=dateB||new Date();return(end.getTime()-dateA.getTime())>threshold;};'use strict';function formatTime(timestamp){if(!timestamp){return _('never');}
var dateFormatter=new navigator.mozL10n.DateTimeFormat();var time=dateFormatter.localeFormat(timestamp,_('shortTimeFormat'));var date=dateFormatter.localeFormat(timestamp,'%a');var dateDay=parseInt(dateFormatter.localeFormat(timestamp,'%u'),10);var now=new Date();var nowDateDay=parseInt(dateFormatter.localeFormat(now,'%u'),10);if(nowDateDay===dateDay){date=_('today');}else if((nowDateDay===dateDay+1)||(nowDateDay===1&&dateDay===7)){date=_('yesterday');}
return navigator.mozL10n.get('day-hour-format',{day:date,time:time});}
function formatBalance(balance){var formattedBalance='--';if(balance!==null){var splitBalance=(balance.toFixed(2)).split('.');formattedBalance='&i.&d'.replace('&i',splitBalance[0]).replace('&d',splitBalance[1]);}
return formattedBalance;}
function formatData(dataArray){return _('magnitude',{value:dataArray[0],unit:dataArray[1]});}
function roundData(value,positions){positions=(typeof positions==='undefined')?2:positions;if(value<1000){return[value.toFixed(positions),'B'];}
if(value<1000000){return[(value/1000).toFixed(positions),'KB'];}
if(value<1000000000){return[(value/1000000).toFixed(positions),'MB'];}
return[(value/1000000000).toFixed(positions),'GB'];}
function getPositions(value){if(value<10){return 2;}
if(value<100){return 1;}
return 0;}
function smartRound(value){var positions;if(value<1000){return[value.toFixed(getPositions(value)),'B'];}
if(value<1000000){var kbytes=value/1000;return[kbytes.toFixed(getPositions(kbytes)),'KB'];}
if(value<1000000000){var mbytes=value/1000000;return[mbytes.toFixed(getPositions(mbytes)),'MB'];}
var gbytes=value/1000000000;return[gbytes.toFixed(getPositions(gbytes)),'GB'];}
function padData(v){var rounded=roundData(v,0);var value=rounded[0];var len=value.length;switch(len){case 1:value='00'+value;break;case 2:value='0'+value;break;}
rounded[0]=parseInt(value,10)?value:'0';return rounded;}
function computeTelephonyMinutes(activity){return Math.ceil(activity.calltime/60000);};'use strict';function checkSIMChange(callback,onerror){asyncStorage.getItem('lastSIM',function _compareWithCurrent(lastSIM){var currentSIM=window.navigator.mozMobileConnection.iccInfo.iccid;if(currentSIM===null){console.error('Impossible: or we don\'t have SIM (so this method '+'should not be called) or the RIL is returning null '+'from time to time when checking ICCID.');if(typeof onerror==='function'){onerror();}
return;}
if(lastSIM!==currentSIM){debug('SIM change!');MindGap.updateTagList(currentSIM);}
ConfigManager.requestSettings(function _onSettings(settings){if(settings.nextReset){setNextReset(settings.nextReset,callback);return;}
if(callback){callback();}});});}
function checkDataUsageNotification(settings,usage,callback){var proxy=document.getElementById('message-handler').contentWindow;var f=proxy?proxy.checkDataUsageNotification:window.checkDataUsageNotification;return f(settings,usage,callback);}
function waitForDOMAndMessageHandler(window,callback){var remainingSteps=2;function checkReady(evt){debug(evt.type,'event received!');remainingSteps--;if(!remainingSteps){window.removeEventListener('DOMContentLoaded',checkReady);window.removeEventListener('messagehandlerready',checkReady);debug('DOMContentLoaded and messagehandlerready received. Starting');callback();}}
window.addEventListener('DOMContentLoaded',checkReady);window.addEventListener('messagehandlerready',checkReady);}
function addAlarmTimeout(type,delay){var proxy=document.getElementById('message-handler').contentWindow;return proxy.addAlarmTimeout(type,delay);}
function setNextReset(when,callback){var proxy=document.getElementById('message-handler');return proxy?proxy.contentWindow.setNextReset(when,callback):window.setNextReset(when,callback);}
function getTopUpTimeout(callback){var proxy=document.getElementById('message-handler');return proxy?proxy.contentWindow.getTopUpTimeout(callback):window.getTopUpTimeout(callback);}
function updateNextReset(trackingPeriod,value,callback){if(trackingPeriod==='never'){setNextReset(null,callback);return;}
var nextReset,today=new Date();if(trackingPeriod==='monthly'){var month,year;var monthday=parseInt(value,10);month=today.getMonth();year=today.getFullYear();if(today.getDate()>=monthday){month=(month+1)%12;if(month===0){year++;}}
nextReset=new Date(year,month,monthday);}else if(trackingPeriod==='weekly'){var oneDay=24*60*60*1000;var weekday=parseInt(value,10);var daysToTarget=weekday-today.getDay();if(daysToTarget<=0){daysToTarget=7+daysToTarget;}
nextReset=new Date();nextReset.setTime(nextReset.getTime()+oneDay*daysToTarget);toMidnight(nextReset);}
setNextReset(nextReset,callback);}
function resetData(){asyncStorage.getItem('dataUsageTags',function _updateTags(tags){if(!tags||!tags.length){console.error('dataUsageTags does not exists!');return;}
var now=new Date();var mobileRequest=window.navigator.mozNetworkStats.getNetworkStats({start:now,end:now,connectionType:'mobile'});mobileRequest.onsuccess=function _onMobileForToday(){var data=mobileRequest.result.data;debug('Data length should be 1 and it is',data.length);var currentDataUsage=0;if(data[0].rxBytes){currentDataUsage+=data[0].rxBytes;}
if(data[0].txBytes){currentDataUsage+=data[0].txBytes;}
var tag=tags[tags.length-1];tag.fixing.push([now,currentDataUsage]);for(var i=tags.length-2;i>=0;i--){var ctag=tags[i];if(ctag.sim===tag.sim){tags.splice(i,1);}}
debug('After reset',tags);asyncStorage.setItem('dataUsageTags',tags,function _done(){ConfigManager.setOption({lastDataReset:now});});};var wifiRequest=window.navigator.mozNetworkStats.getNetworkStats({start:now,end:now,connectionType:'wifi'});wifiRequest.onsuccess=function _onWiFiForToday(){var data=wifiRequest.result.data;debug('Data length should be 1 and it is',data.length);var currentWifiUsage=0;if(data[0].rxBytes){currentWifiUsage+=data[0].rxBytes;}
if(data[0].txBytes){currentWifiUsage+=data[0].txBytes;}
asyncStorage.setItem('wifiFixing',currentWifiUsage);};});}
function resetTelephony(){ConfigManager.setOption({lastTelephonyReset:new Date(),lastTelephonyActivity:{calltime:0,smscount:0,timestamp:new Date()}});}
function resetAll(){resetData();resetTelephony();}
function getDataLimit(settings){var multiplier=(settings.dataLimitUnit==='MB')?1000000:1000000000;return settings.dataLimitValue*multiplier;}
function formatTimeHTML(timestampA,timestampB){if(typeof timestampB==='undefined'){return'<time>'+formatTime(timestampA)+'</time>';}
var dateA=new Date(timestampA);var dateB=new Date(timestampB);if(dateA.getFullYear()===dateB.getFullYear()&&dateA.getMonth()===dateB.getMonth()&&dateA.getDay()===dateB.getDay()){return formatTimeHTML(timestampB);}
return'<time>'+formatTime(timestampA)+'</time> – '+'<time>'+formatTime(timestampB)+'</time>';}
function localizeWeekdaySelector(selector){var weekStartsOnMonday=!!parseInt(navigator.mozL10n.get('weekStartsOnMonday'),10);debug('Week starts on monday?',weekStartsOnMonday);var monday=selector.querySelector('.monday');var sunday=selector.querySelector('.sunday');var list=monday.parentNode;if(weekStartsOnMonday){debug('Monday, Tuesday...');list.insertBefore(monday,list.childNodes[0]);list.appendChild(sunday);}else{debug('Sunday, Monday...');list.insertBefore(sunday,list.childNodes[0]);list.insertBefore(monday,sunday.nextSibling);}};var ConfigManager=(function(){'use strict';var today=new Date();var DEFAULT_SETTINGS={'dataLimit':false,'dataLimitValue':1,'dataLimitUnit':'GB','errors':{'INCORRECT_TOPUP_CODE':false,'BALANCE_TIMEOUT':false,'TOPUP_TIMEOUT':false},'fte':true,'waitingForBalance':null,'waitingForTopUp':null,'lastBalance':null,'lastBalanceRequest':null,'lastTopUpRequest':null,'lastDataUsage':{'timestamp':today,'start':today,'end':today,'today':today,'wifi':{'total':0},'mobile':{'total':0}},'lastTelephonyActivity':{'timestamp':today,'calltime':0,'smscount':0},'lastTelephonyReset':today,'lastDataReset':today,'lowLimit':false,'lowLimitThreshold':false,'lowLimitNotified':false,'zeroBalanceNotified':false,'dataUsageNotified':false,'nextReset':null,'plantype':'prepaid','resetTime':1,'trackingPeriod':'monthly','wifiFixing':0};var configuration;function requestConfiguration(callback){if(configuration){setTimeout(function _onConfiguration(){if(callback){callback(configuration);}});return;}
var xhr=new XMLHttpRequest();xhr.overrideMimeType('application/json');xhr.open('GET','js/config.json',true);xhr.send(null);xhr.onreadystatechange=function _xhrStatusChange(evt){if(xhr.readyState!==4){return;}
if(xhr.status===0||xhr.status===200){configuration=JSON.parse(xhr.responseText);debug('OEM configuration done!');if(callback){callback(configuration);}}};}
Date.prototype.toJSON=function(){return{'__date__':this.toISOString()};};function settingsReviver(k,v){if(v===null||typeof v!=='object'||!v.hasOwnProperty('__date__')){return v;}
return new Date(v['__date__']);}
var NO_ICCID='NOICCID';var settings;function requestSettings(callback){var currentICCID=window.navigator.mozMobileConnection.iccInfo.iccid||NO_ICCID;asyncStorage.getItem(currentICCID,function _wrapGetItem(localSettings){try{settings=JSON.parse(localSettings,settingsReviver);}catch(e){}
if(settings===null){settings=deepCopy(DEFAULT_SETTINGS);debug('Storing default settings for ICCID:',currentICCID);asyncStorage.setItem(currentICCID,JSON.stringify(settings));}
if(callback){callback(settings);}});}
function requestAll(callback){requestConfiguration(function _afterConfig(configuration){requestSettings(function _afterSettings(settings){if(callback){callback(configuration,settings);}});});}
function dispatchOptionChange(name,value,oldValue,settings){var event=new CustomEvent('optionchange',{detail:{name:name,value:value,oldValue:oldValue,settings:settings}});window.dispatchEvent(event);debug('Event optionchange dispatched for',name);}
function setOption(options,callback){if(!settings){requestSettings(function _afterEnsuringSettings(){setOption(options,callback);});return;}
var formerValue={};for(var name in options){if(options.hasOwnProperty(name)){formerValue[name]=settings[name];settings[name]=options[name];}}
var currentICCID=window.navigator.mozMobileConnection.iccInfo.iccid||NO_ICCID;asyncStorage.setItem(currentICCID,JSON.stringify(settings),function _onSet(){requestSettings(function _onSettings(settings){for(var name in options){if(options.hasOwnProperty(name)){dispatchOptionChange(name,settings[name],formerValue[name],settings);}}});if(callback){callback();}});}
function syncOption(name,value){var oldValue=settings[name];if(value===undefined){return oldValue;}
var update={};update[name]=value;setOption(update);}
var callbacks;function callCallbacks(evt){debug('Option',evt.detail.name,'has changed!');var callbackCollection=callbacks[evt.detail.name]||[];for(var i=0,callback;callback=callbackCollection[i];i++){callback(evt.detail.value,evt.detail.oldValue,evt.detail.name,evt.detail.settings);}}
function syncObserve(name,callback,avoidInitialCall){debug('Installing observer for',name);if(callbacks===undefined){callbacks={};window.addEventListener('storage',function _onSync(evt){if(evt.key==='sync'){var name=evt.newValue.split('#')[0];var oldValue=settings?settings[name]:undefined;debug('Synchronization request for',name,'received!');requestSettings(function _onSettings(newSettings){settings=newSettings;dispatchOptionChange(name,settings[name],oldValue,settings);});}});window.addEventListener('optionchange',callCallbacks);}
if(callbacks[name]===undefined){callbacks[name]=[];}
if(callbacks[name].indexOf(callback)<0){callbacks[name].push(callback);avoidInitialCall=avoidInitialCall||false;if(!avoidInitialCall&&callback){callback(settings[name],null,name,settings);}}}
function syncRemoveObserver(name,callback){var callbackCollection=callbacks[name];if(!callbackCollection){return;}
var index=callbackCollection.indexOf(callback);if(index>-1){callbackCollection.splice(index,1);}}
function defaultValue(name){return deepCopy(DEFAULT_SETTINGS[name]);}
return{requestAll:requestAll,requestConfiguration:requestConfiguration,requestSettings:requestSettings,setOption:setOption,defaultValue:defaultValue,option:syncOption,observe:syncObserve,removeObserver:syncRemoveObserver,get configuration(){return configuration;}};}());;var MindGap=(function(){'use strict';function inStandAloneMode(){return window.parent.location.pathname==='/handle_gaps.html';}
function updateTagList(newSIM){var now=new Date();asyncStorage.getItem('dataUsageTags',function _onTags(tags){tags=tags||[];var request=window.navigator.mozNetworkStats.getNetworkStats({start:now,end:now,connectionType:'mobile'});request.onsuccess=function _onStats(){var data=request.result.data[0];var currentDataUsage=(data.rxBytes?data.rxBytes:0)+
(data.txBytes?data.txBytes:0);closeLastTag(tags,currentDataUsage,now);openNewTag(tags,newSIM,now);debug('After: ',tags);asyncStorage.setItem('dataUsageTags',tags,function _done(){asyncStorage.setItem('lastSIM',newSIM);});};});}
function openNewTag(tags,newSIM,when){tags.push({sim:newSIM,start:when,fixing:[]});}
function closeLastTag(allTags,currentDataUsage,when){if(!allTags.length){return;}
var tag=allTags[allTags.length-1];tag.actual=currentDataUsage;var tags=getTagsForDate(allTags,when);if(!tags.length){console.error('Impossible, we should be closing an unexistent tag.');return;}
if(tags.length<2){tag.offset=tag.actual;}else{var fixing=getFixingFor(when,tag.fixing);if(fixing!==null){tag.offset=tag.actual-fixing;}else{var sim=tag.sim;var previous=tags[tags.length-2];tag.offset=(tag.actual-previous.actual)+
getLastClosedOffset(sim,tags);}}
tag.end=when;}
function getLastClosedOffset(referenceSIM,tags){for(var i=tags.length-1;i>=0;i--){var ctag=tags[i];if(ctag.sim===referenceSIM&&ctag.end!==undefined){return ctag.offset;}}
return 0;};function getUsage(tags,currentUsage,date){debug('Current TAGS:',tags);debug('Current date:',date);debug('Current usage:',currentUsage);var tag=tags[tags.length-1];var sim=tag.sim;var dateTags=getTagsForDate(tags,date);debug('Last tag:',tag);var usage;for(var i=dateTags.length-1;i>=0;i--){var ctag=dateTags[i];if(ctag.sim===tag.sim){debug('Same SIM tag:',ctag);if(ctag.end===undefined||!sameDate(date,ctag.end)){debug('Open tag case.');var fixing=getFixingFor(date,ctag.fixing);if(fixing!==null){debug('Fixing with:',fixing);usage=currentUsage-fixing;}else{var prevUsage=dateTags[i-1]===undefined?0:dateTags[i-1].actual;var offset=getLastClosedOffset(sim,dateTags);debug('Previous usage:',prevUsage);debug('Last same SIM usage:',offset);usage=currentUsage-prevUsage+offset;}}else{debug('Closed tag case. Taking offset:',ctag.offset);usage=ctag.offset;}
return usage;}}
debug('No tag found!');return usage;}
function getTagsForDate(tags,date){var time=date.getTime();var dateTags=[];for(var i=0,len=tags.length;i<len;i++){var tag=tags[i];if(sameDate(date,tag.start)||tag.end&&sameDate(date,tag.end)||tag.start.getTime()<time&&tag.end===undefined||tag.start.getTime()<time&&time<tag.end.getTime()){dateTags.push(tag);}}
return dateTags;}
function sameDate(dateA,dateB){return dateA.getUTCFullYear()===dateB.getUTCFullYear()&&dateA.getUTCMonth()===dateB.getUTCMonth()&&dateA.getUTCDate()===dateB.getUTCDate();}
function getFixingFor(date,fixingList){fixingList=fixingList||[];for(var i=fixingList.length-1;i>=0;i--){var cfixing=fixingList[i];if(sameDate(cfixing[0],date)){return cfixing[1];}}
return null;}
return{updateTagList:updateTagList,getUsage:getUsage};}());;var CostControl=(function(){'use strict';var costcontrol;function getInstance(onready){debug('Initializing Cost Control');if(costcontrol){debug('Cost Control already ready!');onready(costcontrol);return;}
function setupCostControl(){costcontrol={request:request,isBalanceRequestSMS:isBalanceRequestSMS,getApplicationMode:getApplicationMode,getDataUsageWarning:function _getDataUsageWarning(){return 0.8;}};debug('Cost Control ready!');onready(costcontrol);}
loadAPIs();ConfigManager.requestAll(setupCostControl);}
var sms,connection,telephony,statistics;function loadAPIs(){if('mozSms'in window.navigator){sms=window.navigator.mozSms;}
if('mozMobileConnection'in window.navigator){connection=window.navigator.mozMobileConnection;}
if('mozNetworkStats'in window.navigator){statistics=window.navigator.mozNetworkStats;}
debug('APIs loaded!');}
function getApplicationMode(settings){var simMCC=connection.iccInfo.mcc;var simMNC=connection.iccInfo.mnc;var enabledNetworks=ConfigManager.configuration.enable_on;if(!(simMCC in enabledNetworks)||(enabledNetworks[simMCC].indexOf(simMNC)===-1)){return'DATA_USAGE_ONLY';}
return settings.plantype.toUpperCase();}
function isBalanceRequestSMS(sms,configuration){return sms.body===configuration.balance.text&&sms.receiver===configuration.balance.destination;}
function request(requestObj,callback){ConfigManager.requestAll(function _onInfo(configuration,settings){debug('Request for:',requestObj.type);var force=requestObj.force;var result={};result.type=requestObj.type;switch(requestObj.type){case'balance':var issues=getServiceIssues(settings);if(issues){result.status='error';result.details=issues;result.data=settings.lastBalance;if(callback){callback(result);}
return;}
var costIssues=getCostIssues(configuration);if(!force&&costIssues){result.status='error';result.details=costIssues;result.data=settings.lastBalance;if(callback){callback(result);}
return;}
var isWaiting=settings.waitingForBalance!==null;var timeout=checkEnoughDelay(BALANCE_TIMEOUT,settings.lastBalanceRequest);if(isWaiting&&!timeout&&!force){result.status='in_progress';result.data=settings.lastBalance;if(callback){callback(result);}
return;}
requestBalance(configuration,settings,callback,result);break;case'topup':var issues=getServiceIssues(settings);if(issues){result.status='error';result.details=issues;result.data=settings.lastDataUsage;if(callback){callback(result);}
return;}
var costIssues=getCostIssues(configuration);if(!force&&costIssues){result.status='error';result.details=costIssues;result.data=settings.lastBalance;if(callback){callback(result);}
return;}
var isWaiting=settings.waitingForTopUp!==null;var timeout=checkEnoughDelay(BALANCE_TIMEOUT,settings.lastTopUpRequest);if(isWaiting&&!timeout&&!force){result.status='in_progress';result.data=settings.lastDataUsage;if(callback){callback(result);}
return;}
var code=requestObj.data;requestTopUp(configuration,settings,code,callback,result);break;case'datausage':requestDataStatistics(configuration,settings,callback,result);break;case'telephony':result.data=settings.lastTelephonyActivity;result.status='success';if(callback){callback(result);}
break;}
return;});}
var airplaneMode=false;SettingsListener.observe('ril.radio.disabled',false,function _onValue(value){airplaneMode=value;});function getServiceIssues(settings){if(airplaneMode){return'airplane_mode';}
if(!connection||!connection.voice||!connection.data){return'no_service';}
var mode=getApplicationMode(settings);if(mode!=='PREPAID'){return'no_service';}
var data=connection.data;if(!data.network.shortName&&!data.network.longName){return'no_service';}
var voice=connection.voice;if(voice.signalStrength===null){return'no_coverage';}
return'';}
function getCostIssues(configuration){var inRoaming=connection.voice.roaming;if(inRoaming&&configuration.is_roaming_free!==true){return'non_free_in_roaming';}
if(!inRoaming&&configuration.is_free!==true){return'non_free';}
return'';}
var BALANCE_TIMEOUT=5*60*1000;function requestBalance(configuration,settings,callback,result){debug('Requesting balance...');result.data=settings.lastBalance;var newSMS=sms.send(configuration.balance.destination,configuration.balance.text);newSMS.onsuccess=function _onSuccess(){debug('Request SMS sent! Waiting for response.');var newAlarm=addAlarmTimeout('balanceTimeout',BALANCE_TIMEOUT);newAlarm.onsuccess=function _alarmSet(evt){var id=evt.target.result;debug('Timeout for balance (',id,') update set to:',BALANCE_TIMEOUT);ConfigManager.setOption({'waitingForBalance':id,'lastBalanceRequest':new Date()},function _onSet(){result.status='success';if(callback){callback(result);}});};newAlarm.onerror=function _alarmFailedToSet(evt){debug('Failed to set timeout for balance request!');result.status='error';result.details='timout_fail';if(callback){callback(result);}};};newSMS.onerror=function _onError(){debug('Request SMS failed! But returning stored balance.');result.status='error';result.details='request_fail';if(callback){callback(result);}};debug('Balance out of date. Requesting fresh data...');}
var TOPUP_TIMEOUT=5*60*1000;function requestTopUp(configuration,settings,code,callback,result){debug('Requesting TopUp with code',code,'...');var newSMS=sms.send(configuration.topup.destination,configuration.topup.text.replace(/\&code/g,code));newSMS.onsuccess=function _onSuccess(){debug('TopUp SMS sent! Waiting for response.');var newAlarm=addAlarmTimeout('topupTimeout',TOPUP_TIMEOUT);newAlarm.onsuccess=function _alarmSet(evt){var id=evt.target.result;debug('Timeout for TopUp (',id,') update set to:',TOPUP_TIMEOUT);ConfigManager.setOption({'waitingForTopUp':id,'lastTopUpRequest':new Date()},function _onSet(){result.status='success';if(callback){callback(result);}});};newAlarm.onerror=function _alarmFailedToSet(evt){debug('Failed to set timeout for TopUp request!');result.status='error';result.details='timeout_fail';if(callback){callback(result);}};};newSMS.onerror=function _onError(){debug('TopUp SMS failed!');result.status='error';result.details='request_fail';if(callback){callback(result);}};}
var DAY=24*3600*1000;function requestDataStatistics(configuration,settings,callback,result){debug('Statistics out of date. Requesting fresh data...');var start=toMidnight(new Date(settings.lastDataReset||Date.now()-7*DAY));var today=toMidnight(new Date());var tomorrow=new Date();tomorrow.setTime(today.getTime()+DAY);var end=toMidnight(settings.nextReset?new Date(settings.nextReset.getTime()-DAY):tomorrow);if(start>end){console.error('Start date is higher than end date. This must not '+'happen. Maybe the clock has changed');end=new Date(start.getTime()+DAY);}
asyncStorage.getItem('dataUsageTags',function _onTags(tags){asyncStorage.getItem('wifiFixing',function _onFixing(wifiFixing){var wifiRequest=statistics.getNetworkStats({start:start,end:end,connectionType:'wifi'});wifiRequest.onsuccess=function _onWifiData(){var mobileRequest=statistics.getNetworkStats({start:start,end:end,connectionType:'mobile'});mobileRequest.onsuccess=function _onMobileData(){var fakeTag={sim:connection.iccInfo.iccid,start:settings.lastDataReset,fixing:[[settings.lastDataReset,wifiFixing||0]]};var wifiData=adaptData(wifiRequest.result,[fakeTag]);var mobileData=adaptData(mobileRequest.result,tags);var lastDataUsage={timestamp:new Date(),start:start,end:end,today:today,wifi:{total:wifiData[1]},mobile:{total:mobileData[1]}};ConfigManager.setOption({'lastDataUsage':lastDataUsage},function _onSetItem(){debug('Statistics up to date and stored.');});lastDataUsage.wifi.samples=wifiData[0];lastDataUsage.mobile.samples=mobileData[0];result.status='success';result.data=lastDataUsage;debug('Returning up to date statistics.');if(callback){callback(result);}};};});});}
function adaptData(networkStatsResult,tags){var data=networkStatsResult.data;var output=[];var totalData,accum=0;for(var i=0,item;item=data[i];i++){if(item.txBytes===undefined){output.push({date:item.date});continue;}
totalData=0;if(item.rxBytes){totalData+=item.rxBytes;}
if(item.txBytes){totalData+=item.txBytes;}
var usage=totalData;if(tags){usage=MindGap.getUsage(tags,totalData,item.date);}
if(usage===undefined){continue;}
accum+=usage;output.push({value:usage,date:item.date});}
return[output,accum];}
return{getInstance:getInstance};}());;(function(){'use strict';function inStandAloneMode(){return window.parent.location.pathname==='/message_handler.html';}
if(!inStandAloneMode()){ConfigManager=window.parent.ConfigManager;CostControl=window.parent.CostControl;}
if(inStandAloneMode()&&window.history.length>1){debug('Nothing to do, closing...');window.history.back();}
function inApplicationMode(){return window.parent.location.pathname==='/index.html';}
var closing;function closeIfProceeds(){debug('Trying to close...');if(inStandAloneMode()){closing=setTimeout(function _close(){window.close();debug('Closing message handler');},1000);}}
function addAlarmTimeout(type,delay){var date=new Date();date.setTime(date.getTime()+delay);var request=navigator.mozAlarms.add(date,'ignoreTimezone',{type:type});return request;};window.addAlarmTimeout=addAlarmTimeout;function setNextReset(when,callback){asyncStorage.getItem('nextResetAlarm',function(id){debug('Current nextResetAlarm',id+'.',id?'Removing.':'');if(id){navigator.mozAlarms.remove(id);}
if(!when){debug('Automatic reset disabled');updateResetAttributes(null,null,callback);return;}
if(when.getTime()<Date.now()){debug('Faking a past reset alarm');_onAlarm({data:{type:'nextReset'}});if(callback){setTimeout(callback);}
return;}
var alarms=navigator.mozAlarms;var request=alarms.add(when,'ignoreTimezone',{type:'nextReset'});request.onsuccess=function _onSuccess(){debug('Setting nextResetAlarm',request.result,'to',when);updateResetAttributes(request.result,when,callback);};});}
window.setNextReset=setNextReset;function getTopUpTimeout(callback){ConfigManager.requestSettings(function _onSettings(settings){var request=navigator.mozAlarms.getAll();request.onsuccess=function(e){var alarms=e.target.result;var length=alarms.length;if(!length){callback(null);return;}
var refId=settings.waitingForTopUp;var index=0,alarm,found=false;while(index<length&&!found){alarm=alarms[index];found=(alarm.id===refId);index++;}
if(found){debug('TopUp timeout found:',alarm.date);callback(alarm.date);}else{callback(null);}};});}
window.getTopUpTimeout=getTopUpTimeout;function updateResetAttributes(alarmId,date,callback){asyncStorage.setItem('nextResetAlarm',alarmId,function _updateOption(){ConfigManager.setOption({nextReset:date},function _sync(){localStorage['sync']='nextReset#'+Math.random();if(callback){callback();}});});}
function sendIncorrectTopUpNotification(callback){navigator.mozApps.getSelf().onsuccess=function _onAppReady(evt){var app=evt.target.result;var iconURL=NotificationHelper.getIconURI(app);var goToTopUpCode;if(!inStandAloneMode()){goToTopUpCode=function _goToTopUpCode(){app.launch();window.parent.BalanceTab.topUpWithCode(true);};}
iconURL+='?topUpError';NotificationHelper.send(_('topup-incorrectcode-title2'),_('topup-incorrectcode-message2'),iconURL,goToTopUpCode);if(callback){callback();}};}
function sendBalanceThresholdNotification(remaining,settings,callback){navigator.mozApps.getSelf().onsuccess=function _onAppReady(evt){var app=evt.target.result;var iconURL=NotificationHelper.getIconURI(app);var goToBalance;if(!inStandAloneMode()){goToBalance=function _goToBalance(){app.launch();window.parent.CostControlApp.showBalanceTab();};}
debug('Low limit already notified:',settings.lowLimitNotified);debug('Zero balance already notified:',settings.lowLimitNotified);var type;if(remaining.balance===0&&!settings.zeroBalanceNotified){type='zeroBalance';}else if(settings.lowLimit&&remaining.balance<settings.lowLimitThreshold&&!settings.lowLimitNotified){type='lowBalance';}else{return;}
debug('Notification type:',type);iconURL+='?'+type;var remainingBalance=_('currency',{currency:remaining.currency,value:remaining.balance});var title=_('low-balance-notification-title');var message=_('low-balance-notification-text',{remaining:remainingBalance});if(type==='zeroBalance'){title=_('usage');message=_('zero-balance-message');}
NotificationHelper.send(title,message,iconURL,goToBalance);var update={};var notified=(type==='lowBalance')?'lowLimitNotified':'zeroBalanceNotified';update[notified]=true;ConfigManager.setOption(update,callback);};}
function _onAlarm(alarm){clearTimeout(closing);switch(alarm.data.type){case'balanceTimeout':ConfigManager.requestSettings(function _onSettings(settings){settings.errors['BALANCE_TIMEOUT']=true;ConfigManager.setOption({'errors':settings.errors,'waitingForBalance':null},function _onBalanceTimeout(){debug('Timeout for balance');debug('Trying to synchronize!');localStorage['sync']='errors#'+Math.random();closeIfProceeds();});});break;case'topupTimeout':ConfigManager.requestSettings(function _onSettings(settings){settings.errors['TOPUP_TIMEOUT']=true;ConfigManager.setOption({'errors':settings.errors,'waitingForTopUp':null},function _onBalanceTimeout(){debug('Timeout for topup');debug('Trying to synchronize!');localStorage['sync']='errors#'+Math.random();closeIfProceeds();});});break;case'nextReset':ConfigManager.requestSettings(function _onSettings(settings){resetAll();updateNextReset(settings.trackingPeriod,settings.resetTime);closeIfProceeds();});break;}}
function checkDataUsageNotification(settings,usage,callback){navigator.mozApps.getSelf().onsuccess=function _onAppReady(evt){var app=evt.target.result;var iconURL=NotificationHelper.getIconURI(app);iconURL+='?dataUsage';var goToDataUsage;if(!inStandAloneMode()){goToDataUsage=function _goToDataUsage(){app.launch();window.parent.CostControlApp.showDataUsageTab();};}
var limit=getDataLimit(settings);if(settings.dataLimit){if(usage>=limit&&!settings.dataUsageNotified){var limitText=formatData(smartRound(limit));var title=_('data-limit-notification-title',{limit:limitText});var message=_('data-limit-notification-text');NotificationHelper.send(title,message,iconURL,goToDataUsage);ConfigManager.setOption({'dataUsageNotified':true},callback);return true;}else if(usage<limit&&settings.dataUsageNotified){ConfigManager.setOption({'dataUsageNotified':false},callback);return false;}}
if(callback){callback();}
return false;};}
window.checkDataUsageNotification=checkDataUsageNotification;var costcontrol;CostControl.getInstance(function _onCostControl(ccontrol){costcontrol=ccontrol;if(inStandAloneMode()||inApplicationMode()){debug('Installing handlers');navigator.mozSetMessageHandler('sms-received',function _onSMS(sms){clearTimeout(closing);ConfigManager.requestAll(function _onInfo(configuration,settings){if(configuration.balance.senders.indexOf(sms.sender)===-1&&configuration.topup.senders.indexOf(sms.sender)===-1){closeIfProceeds();return;}
debug('Parsing received SMS');var isBalance,isConfirmation,isError;isBalance=isConfirmation=isError=false;debug('Trying to recognize balance SMS');var description=new RegExp(configuration.balance.regexp);var balanceData=sms.body.match(description);isBalance=!!balanceData;if(!isBalance||balanceData.length<2){console.warn('Impossible to parse balance message.');debug('Trying to recognize TopUp confirmation SMS');description=new RegExp(configuration.topup.confirmation_regexp);isConfirmation=!!sms.body.match(description);if(!isConfirmation){console.warn('Impossible to parse TopUp confirmation message.');debug('Trying to recognize TopUp error SMS');description=new RegExp(configuration.topup.incorrect_code_regexp);isError=!!sms.body.match(description);if(!isError){console.warn('Impossible to parse TopUp confirmation message.');}}}
if(!isBalance&&!isConfirmation&&!isError){return;}
if(isBalance){var integer=balanceData[1];var decimal=balanceData[2]||'0';var newBalance={balance:parseFloat(integer+'.'+decimal),currency:configuration.credit.currency,timestamp:new Date()};navigator.mozAlarms.remove(settings.waitingForBalance);debug('Balance timeout:',settings.waitingForBalance,'removed');ConfigManager.setOption({'lastBalance':newBalance,'waitingForBalance':null},function _onSet(){debug('Balance up to date and stored');debug('Trying to synchronize!');localStorage['sync']='lastBalance#'+Math.random();sendBalanceThresholdNotification(newBalance,settings,closeIfProceeds);});}else if(isConfirmation){navigator.mozAlarms.remove(settings.waitingForTopUp);debug('TopUp timeout:',settings.waitingForTopUp,'removed');ConfigManager.setOption({'waitingForTopUp':null,'lowLimitNotified':false,'zeroBalanceNotified':false},function _onSet(){debug('TopUp confirmed!');debug('Trying to synchronize!');localStorage['sync']='waitingForTopUp#'+Math.random();closeIfProceeds();});}else if(isError){settings.errors['INCORRECT_TOPUP_CODE']=true;navigator.mozAlarms.remove(settings.waitingForTopUp);debug('TopUp timeout: ',settings.waitingForTopUp,'removed');ConfigManager.setOption({'errors':settings.errors,'waitingForTopUp':null,'lowLimitNotified':false,'zeroBalanceNotified':false},function _onSet(){debug('Balance up to date and stored');debug('Trying to synchronize!');localStorage['sync']='errors#'+Math.random();sendIncorrectTopUpNotification(closeIfProceeds);});}});});navigator.mozSetMessageHandler('alarm',_onAlarm);navigator.mozSetMessageHandler('sms-sent',function _onSent(sms){clearTimeout(closing);debug('SMS sent!');ConfigManager.requestAll(function _onInfo(configuration,settings){var mode=costcontrol.getApplicationMode(settings);if(mode==='PREPAID'&&!costcontrol.isBalanceRequestSMS(sms,configuration)){costcontrol.request({type:'balance'});}
var manager=window.navigator.mozSms;var smsInfo=manager.getSegmentInfoForText(sms.body);var realCount=smsInfo.segments;settings.lastTelephonyActivity.timestamp=new Date();settings.lastTelephonyActivity.smscount+=realCount;ConfigManager.setOption({lastTelephonyActivity:settings.lastTelephonyActivity},function _sync(){localStorage['sync']='lastTelephonyActivity#'+Math.random();closeIfProceeds();});});});navigator.mozSetMessageHandler('telephony-call-ended',function _onCall(tcall){clearTimeout(closing);if(tcall.direction!=='outgoing'){return;}
debug('Outgoing call finished!');ConfigManager.requestSettings(function _onSettings(settings){var mode=costcontrol.getApplicationMode(settings);if(mode==='PREPAID'){costcontrol.request({type:'balance'});}
settings.lastTelephonyActivity.timestamp=new Date();settings.lastTelephonyActivity.calltime+=tcall.duration;ConfigManager.setOption({lastTelephonyActivity:settings.lastTelephonyActivity},function _sync(){localStorage['sync']='lastTelephonyActivity#'+Math.random();closeIfProceeds();});});});}
var readyEvent=new CustomEvent('messagehandlerready');window.parent.dispatchEvent(readyEvent);});}());